unit ExitUnit;

interface

uses Skylib,Inifiles,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls;

Procedure SetLang;

type
  TExitForm = class(TForm)
    Label1: TLabel;
    RadioGroup1: TRadioGroup;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    CheckBox1: TCheckBox;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ExitForm: TExitForm;

implementation

{$R *.DFM}

Procedure SetLang;
var section : string;
    inifile : Tmeminifile;
const deftxt = '?';
begin
if language>'0' then begin
inifile:=Tmeminifile.create(AppDir+'\language_'+language+'.ini');
section:='exit';
with ExitForm do
  with inifile do begin
    Caption:=ReadString(section,'title',deftxt);
    Radiogroup1.Caption:=ReadString(section,'t_1',deftxt);
    Radiogroup1.Items[0]:=ReadString(section,'t_2',deftxt);
    Radiogroup1.Items[1]:=ReadString(section,'t_3',deftxt);
    BitBtn1.Caption:=ReadString(section,'t_4',deftxt);
    Checkbox1.Caption:=ReadString(section,'t_5',deftxt);
    BitBtn2.Caption:=ReadString('buttons','cancel',deftxt);
  end;
inifile.free;
end;
end;


procedure TExitForm.FormCreate(Sender: TObject);
begin
SetLang;
end;

end.
