unit ExtUnit;

interface

uses SkyLib,Inifiles,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, OleCtnrs, blcksock, HTTPsend, FTPSend,
  HiResTim ;

Procedure SetLang;

type
  TExtForm = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label4: TLabel;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    Panel1: TPanel;
    Label5: TLabel;
    msg: TEdit;
    Timer1: THiResTimer;
    Memo1: TMemo;
    procedure FormShow(Sender: TObject);
    procedure SockStatus(Sender: TObject; Reason: THookSocketReason; Const Value: string) ;
    procedure BitBtn2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure Panel1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FTPStatus(Sender: TObject; Response: Boolean; Const Value: string);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure HttpError;
    procedure HttpSuccess;
    procedure FTPSuccess;
    procedure FTPError;
  end;

procedure GetExt(res,filename,oldname : string);
Procedure ModUrl(pattern,buf : string);

var
  ExtForm: TExtForm;
  http: THTTPSend;
  ftp : TFTPSend;

implementation

var  InfoUrl,url,url2,method,proxy,proxyport,proxyuser,proxypass,fname,oname,infomsg,ftpfile,ftpdir,ftptmp : string;
     FWPassive : boolean;
     FWHost,FWPort,FWUsername,FWPassword:string;
     nl,sockreadcount,sockwritecount,FWMode : integer;

{$R *.DFM}

Procedure SetLang;
var section : string;
    inifile : Tmeminifile;
const deftxt = '?';
begin
infomsg:='Pour plus d''information :';
if language>'0' then begin
inifile:=Tmeminifile.create(AppDir+'\language_'+language+'.ini');
section:='extres';
with ExtForm do
  with inifile do begin
    Caption:=ReadString(section,'t_1',deftxt);
    Label1.Caption:=ReadString(section,'t_2',deftxt);
    Label2.Caption:=ReadString(section,'t_3',deftxt);
    infomsg:=ReadString(section,'t_5',deftxt);
    BitBtn1.Caption:=ReadString('buttons','ok',deftxt);
    BitBtn2.Caption:=ReadString('buttons','cancel',deftxt);
    BitBtn3.Caption:=ReadString(section,'t_4',deftxt);
    BitBtn4.Caption:=ReadString('buttons','help',deftxt);
  end;
inifile.free;
end;
end;

procedure GetExt(res,filename,oldname : string);
var inifile : Tinifile;
begin
Extform.Label4.Caption:=res;
fname:=filename;
oname:=oldname;
inifile:=Tinifile.create('.\extres.ini');
with inifile do begin
if SectionExists(res) then begin
url:=ReadString(res,'url',' ');
url2:=ReadString(res,'url2','');
method:=ReadString(res,'method','get');
InfoUrl:=ReadString(res,'info','');
proxy:=ReadString('proxy','proxy','');
proxyport:=ReadString('proxy','proxyport','');
proxyuser:=ReadString('proxy','proxyuser','');
proxypass:=ReadString('proxy','proxypass','');
FWmode:=ReadInteger('ftp_firewall','mode',0);
FWPassive:=ReadBool('ftp_firewall','passv',true);
FWHost:=ReadString('ftp_firewall','host','');
FWPort:=ReadString('ftp_firewall','port','');
FWUsername:=ReadString('ftp_firewall','user','');
FWPassword:=ReadString('ftp_firewall','pass','');
end else begin
url:=' ';
url2:='';
infourl:='';
end;
end;
inifile.free;
if InfoUrl='' then Extform.Label5.Caption:=''
              else Extform.Label5.Caption:=infomsg+' '+InfoUrl;
end;

Procedure ModUrl(pattern,buf : string);
var i,l : integer;
begin
i:=pos(pattern,url);
l:=length(pattern);
if i>0 then begin
  url:=copy(url,1,i-1)+buf+copy(url,i+l,99999);
end;

end;

procedure TExtForm.HttpError;
begin
edit3.Text:=edit3.text+' / Error: '+inttostr(http.ResultCode)+' '+http.ResultString;
end;

procedure TExtForm.HttpSuccess;
var c : char;
    i,j,n,gzfile : integer;
    line,tmpname : string;
    f,o : textfile;
    ok : boolean;
    fitsfile,tmpfile : file;
//    fitsbuf : array[1..2880] of char;
    buf : array[0..4095]of char;
begin
 line:='';
 nl:=0;
 ok:=false;
 if (copy(Extform.Label4.Caption,1,7)='ESO_DSS') then begin
    assignfile(fitsfile,fname);
    rewrite(fitsfile,1);
 end else begin
    assignfile(f,fname);
    rewrite(f);
 end;
 if Extform.Label4.Caption='ESO_USNO-A' then begin
   http.Document.Position:=0;
   repeat
     i:=http.Document.Read(c,1);
     if i=1 then begin
     case c of
      #13  : continue;
      #10  : begin
             if pos('ID ',line)>0 then begin ok:=true;line:='';continue;end;
             if pos('[EOD]',line)>0 then begin ok:=false;line:='';continue;end;
             if ok then begin inc(nl); writeln(f,line); end;
             line:='';
             end;
      else line:=line+c;
      end;
      end;
   until i=0;
 end else  if copy(Extform.Label4.Caption,1,10)='STSCI_GSC1' then begin
   http.Document.Position:=0;
   repeat
     i:=http.Document.Read(c,1);
     if i=1 then begin
     case c of
      #13  : continue;
      #10  : begin
             if pos('Guide Star ID',line)>0 then begin ok:=true;line:='';continue;end;
             if pos('The GSC may be',line)>0 then begin ok:=false;line:='';continue;end;
             if ok then begin inc(nl); writeln(f,line); end;
             line:='';
             end;
      else line:=line+c;
      end;
      end;
   until i=0;
 end else  if copy(Extform.Label4.Caption,1,10)='STSCI_GSC2' then begin
   http.Document.Position:=0;
   repeat
     i:=http.Document.Read(c,1);
     if i=1 then begin
     case c of
      #13  : continue;
      #10  : begin
             if pos('----',line)>0 then begin ok:=true;line:='';continue;end;
             if pos('[EOD]',line)>0 then begin ok:=false;line:='';continue;end;
             if ok then begin inc(nl); writeln(f,line); end;
             line:='';
             end;
      else line:=line+c;
      end;
      end;
   until i=0;
 end else  if Extform.Label4.Caption='ESO_GSC' then begin
   http.Document.Position:=0;
   repeat
     i:=http.Document.Read(c,1);
     if i=1 then begin
     case c of
      #13  : continue;
      #10  : begin
             if pos('gsc_id ',line)>0 then begin ok:=true;line:='';continue;end;
             if pos('[EOD]',line)>0 then begin ok:=false;line:='';continue;end;
             if ok then begin inc(nl); writeln(f,line);end;
             line:='';
             end;
      else line:=line+c;
      end;
      end;
   until i=0;
 end else  if copy(Extform.Label4.Caption,1,7)='ESO_DSS' then begin
    if copy(Extform.Label4.Caption,length(Extform.Label4.Caption)-1,2)='GZ' then begin
      tmpname:=gettempfile(123);
      http.Document.Position:=0;
      http.Document.SaveToFile(tmpname);
      if zlibok then begin
        gzfile:=gzopen(pchar(tmpname),pchar('rb'));
        repeat
            i:=gzread(gzfile,buf,length(buf));
             blockwrite(fitsfile,buf,i,n);
        until gzeof(gzfile)=1;
        gzclose(gzfile);
        nl:=filesize(fitsfile) div 2880;
        CloseFile(fitsfile);
      end else begin
        assignfile(tmpfile,tmpname);
        reset(tmpfile,1);
        repeat
           blockread(tmpfile,buf,length(buf),i);
           blockwrite(fitsfile,buf,i,n);
        until eof(tmpfile);
        closefile(tmpfile);
        nl:=filesize(fitsfile) div 2880;
        CloseFile(fitsfile);
      end;
    end else begin
      CloseFile(fitsfile);
      nl:=http.Document.Size div 2880;
      http.Document.Position:=0;
      http.Document.SaveToFile(fname);
    end;
 end else  if copy(Extform.Label4.Caption,1,6)='VizieR' then begin
   http.Document.Position:=0;
   repeat
     i:=http.Document.Read(c,1);
     if i=1 then begin
     case c of
      #13  : continue;
      #10  : begin
             if pos('VizieR-5?',line)>0 then begin
                j:=pos('</A>',line);
                if j>0 then begin
                  line:=copy(line,j+4,99999);
                  writeln(f,line);
                  inc(nl);
                end;
             end;
             line:='';
             end;
      else line:=line+c;
      end;
      end;
   until i=0;
 end else begin
   http.Document.Position:=0;
   repeat
     i:=http.Document.Read(c,1);
     if i=1 then begin
     case c of
      #13  : continue;
      #10  : begin
             writeln(f,line);
             inc(nl);
             line:='';
             end;
      else line:=line+c;
      end;
      end;
   until i=0;
 end;
 if (oname<>'') and fileexists(oname) then begin
   assignfile(o,oname);
   reset(o);
   repeat
     Readln(o,line);
     Writeln(f,line);
   until eof(o);
   Closefile(o);
 end;
 if (copy(Extform.Label4.Caption,1,7)<>'ESO_DSS') then CloseFile(f);
 Edit3.text:=edit3.text+(' Ended. Lines/Block read = '+inttostr(nl));
 BitBtn1.Visible:=true;
 BitBtn2.Visible:=false;
 if nl=0 then begin
   http.Document.Position:=0;
   repeat
   line:='';
   i:=http.Document.Read(c,1);
   while ((c<>#10) or (line='')) and (i=1) do begin
     if c='<' then begin
       repeat i:=http.Document.Read(c,1) until (c='>') or (i<>1);
       i:=http.Document.Read(c,1);
       continue;
     end;
     if c=#9 then begin i:=http.Document.Read(c,1); continue; end;
     if c=#10 then begin i:=http.Document.Read(c,1); continue; end;
     if c=#13 then begin i:=http.Document.Read(c,1); continue; end;
     line:=line+c;
     i:=http.Document.Read(c,1);
   end;
   if trim(line)>'' then memo1.Lines.Add(line);
   until i=0;
 end;
end;

procedure TExtForm.FormShow(Sender: TObject);
var i :integer;
begin
memo1.Clear;
memo1.Visible:=false;
BitBtn1.Visible:=false;
BitBtn2.Visible:=true;
BitBtn3.Visible:=true;
edit1.text:=url;
if url2>'' then begin
  i:=LastDelimiter('/',url2);
  edit1.Text:=edit1.Text+' + '+copy(url2,i+1,99);
end;
edit2.text:=fname;
nl:=0;
end;


procedure TExtForm.SockStatus(Sender: TObject; Reason: THookSocketReason; Const Value: string) ;
var reasontxt:string;
begin
case reason of
HR_ResolvingBegin : reasontxt:='Resolving '+value;
HR_Connect        : reasontxt:='Connect '+value;
HR_Accept         : reasontxt:='Accept '+value;
HR_ReadCount      : begin
                    Sockreadcount:=Sockreadcount+strtoint(value);
                    reasontxt:='Read Bytes: '+inttostr(Sockreadcount);
                    end;
HR_WriteCount     : begin
                    Sockwritecount:=Sockwritecount+strtoint(value);
                    reasontxt:='Request sent, waiting response';
                    end;
else reasontxt:='';
end;
if reasontxt>'' then begin
  edit3.text:=reasontxt;
  edit3.refresh;
end;
end;

procedure TExtForm.BitBtn2Click(Sender: TObject);
begin                
if copy(url,1,4)='http' then http.Sock.CloseSocket
                        else ftp.abort;
 BitBtn1.Visible:=true;
 BitBtn2.Visible:=false;
 Application.processmessages;
//   ExtForm.Close;
end;

procedure TExtForm.Timer1Timer(Sender: TObject);
var buf,savename : string;
    i : integer;
    ok:boolean;
begin
timer1.enabled:=false;
if copy(url,1,4)='http' then begin        // HTTP protocol
http.Clear;
http.Timeout:=300000;
sockreadcount:=0;
sockwritecount:=0;
if proxy<>'' then http.ProxyHost:=proxy;
if proxyport<>'' then http.ProxyPort:=proxyport;
if proxyuser<>'' then http.ProxyUser :=proxyuser;
if proxypass<>'' then http.ProxyPass :=proxypass;
http.Sock.OnStatus:=SockStatus;
try
  if url2<>'' then begin
  savename:=fname;
  try
  fname:=gettempfile(1234);
  if http.HTTPMethod('GET', url2)
     and ((http.ResultCode=200)
       or (http.ResultCode=0))
     then httpsuccess
     else httperror;
  http.Clear;
  BitBtn3.Visible:=false;
  BitBtn1.Visible:=false;
  BitBtn2.Visible:=true;
  finally
  oname:=fname;
  fname:=savename;
  end;
  end;
  if http.HTTPMethod('GET', url)
     and ((http.ResultCode=200)
       or (http.ResultCode=0))
     then httpsuccess
     else httperror;
finally
http.Clear;
end;
end else begin                // FTP protocol
if copy(url,1,3)<>'ftp' then exit;
i:=pos('://',url);
buf:=copy(url,i+3,999);
i:=pos('/',buf);
ftp.Targethost:=copy(buf,1,i-1);
ftp.PassiveMode:=FWpassive;
ftp.FWMode:=FWMode;
if FWhost<>'' then ftp.FWHost:=FWHost;
if FWport<>'' then ftp.FWPort:=FWPort;
if FWUsername<>'' then ftp.FWUsername:=FWUsername;
if FWPassword<>'' then ftp.FWPassword:=FWPassword;
ftp.OnStatus:=ftpstatus;
sockreadcount:=0;
sockwritecount:=0;
ftp.Sock.OnStatus:=SockStatus;
buf:=copy(buf,i,999);
i:=LastDelimiter('/',buf);
ftpdir:=copy(buf,1,i);
ftpfile:=copy(buf,i+1,999);
ftptmp:=gettempfile(123);
deletefile(ftptmp);
if ftp.Login then begin
  ftp.ChangeWorkingDir(ftpdir);
  ftp.DirectFile:=true;
  ftp.DirectFileName:=ftptmp;
  ok:=ftp.RetrieveFile(ftpfile,false);
  ftp.logout;
  if ok then FtpSuccess
        else ftperror;
end;
end;
if memo1.Text<>'' then begin
   memo1.Visible:=true;
   memo1.BringToFront;
end;   
end;

procedure TExtForm.FormCreate(Sender: TObject);
begin
SetLang;
http := THTTPSend.Create;
ftp := TFTPSend.Create;
end;

procedure TExtForm.BitBtn3Click(Sender: TObject);
var buf : string;
begin
edit3.text:='Request data from the server';
if (ExtractFileExt(edit2.text)='.')or(ExtractFileExt(edit2.text)='') then edit2.text:=ChangeFileExt(edit2.text,'.cat');
fname:=edit2.text;
buf:=ExtractFilepath(fname);
if not directoryexists(buf) then forcedirectories(buf);
extform.refresh;
Timer1.enabled:=true;
BitBtn3.Visible:=false;
end;

procedure TExtForm.Panel1Click(Sender: TObject);
begin
if infourl>'' then ExecuteFile(InfoUrl, '', '', SW_SHOWNOACTIVATE);
end;

procedure TExtForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
msg.text:='';
end;

procedure TExtForm.ftpError;
begin
edit3.Text:=edit3.text+' / Error: '+inttostr(ftp.ResultCode)+' '+ftp.ResultString;
end;

procedure TExtForm.FTPSuccess;
var i,gzfile,j : integer;
    f : textfile;
    buf : array[0..4095]of char;
    wbuf,line : string;
    lf : char;
begin
nl:=0;
   lf:=chr(10);
   gzfile:=gzopen(pchar(ftptmp),pchar('rb'));
   assignfile(f,fname);
   rewrite(f);
   wbuf:='';
   repeat
       i:=gzread(gzfile,buf,length(buf));
       wbuf:=wbuf+copy(buf,0,i);
       repeat
         j:=pos(lf,wbuf);
         if j>0 then begin
           line:=copy(wbuf,1,j-1);
           wbuf:=copy(wbuf,j+1,9999);
           writeln(f,line);
           inc(nl);
         end;
       until j=0;
   until gzeof(gzfile)=1;
   gzclose(gzfile);
   closefile(f);
   Edit3.text:=edit3.text+(' Ended. Lines/Block read = '+inttostr(nl));
   BitBtn1.Visible:=true;
   BitBtn2.Visible:=false;
end;

procedure TExtForm.FTPStatus(Sender: TObject; Response: Boolean; Const Value: string);
begin
if response then edit3.text:=value;
edit3.refresh;
end;

procedure TExtForm.BitBtn4Click(Sender: TObject);
begin
showhelp('doc3.html#internet');
end;

procedure TExtForm.BitBtn1Click(Sender: TObject);
begin
if nl>0 then modalresult:=mrOK else modalresult:=mrCancel;
end;

procedure TExtForm.FormDestroy(Sender: TObject);
begin
http.Free;
ftp.Free;
end;

end.
