unit Sky_P2;

interface

uses
  SkyLib,IniFiles,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, EnhEdits;

Procedure SetLang;

type
  TForm2 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Label10: TLabel;
    Edit7: TEdit;
    UpDown1: TUpDown;
    SpeedButton1: TSpeedButton;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    LongEdit1: TLongEdit;
    LongEdit2: TLongEdit;
    LongEdit3: TLongEdit;
    LongEdit4: TLongEdit;
    LongEdit5: TLongEdit;
    LongEdit6: TLongEdit;
    LongEdit8: TLongEdit;
    LongEdit9: TLongEdit;
    LongEdit10: TLongEdit;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    LongEdit7: TLongEdit;
    LongEdit11: TLongEdit;
    LongEdit12: TLongEdit;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    LongEdit13: TLongEdit;
    LongEdit14: TLongEdit;
    LongEdit15: TLongEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure LongEdit1Change(Sender: TObject);
    procedure LongEdit7Change(Sender: TObject);
    procedure LongEdit1Enter(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form2: TForm2;
  ar1,ar2,de1,de2 : Double;
  arc,dec,la,th : Double;
  skipaz : boolean;

implementation

{$R *.DFM}

Procedure SetLang;
var section : string;
    inifile : Tmeminifile;
const deftxt = '?';
begin
if language>'0' then begin
inifile:=Tmeminifile.create(AppDir+'\language_'+language+'.ini');
section:='coordinate';
with Form2 do
  with inifile do begin
    Label1.Caption:=ReadString(section,'t_1',deftxt);
    Label3.Caption:=ReadString(section,'t_2',deftxt);
    Label2.Caption:=ReadString(section,'t_3',deftxt);
    Label10.Caption:=ReadString(section,'t_4',deftxt);
    SpeedButton1.Caption:=ReadString(section,'t_5',deftxt);
    BitBtn1.Caption:=ReadString('buttons','ok',deftxt);
    BitBtn2.Caption:=ReadString('buttons','cancel',deftxt);
    BitBtn3.Caption:=ReadString('buttons','help',deftxt);
    Label14.Caption:=ReadString('main','m_20',deftxt);
    Label18.Caption:=ReadString('main','m_21',deftxt);
    label6.Caption:=ldeg;
    label15.Caption:=ldeg;
    label19.Caption:=ldeg;
    label8.Caption:=ldeg;
    label7.Caption:=lmin;
    label16.Caption:=lmin;
    label20.Caption:=lmin;
    label9.Caption:=lmin;
    label12.Caption:=lsec;
    label17.Caption:=lsec;
    label21.Caption:=lsec;
    label13.Caption:=lsec;

  end;
inifile.free;
end;
end;

procedure TForm2.Button1Click(Sender: TObject);
var dd,s : integer;
begin
   arc := LongEdit1.value+LongEdit4.value/60+LongEdit8.value/3600;
   dd  := LongEdit2.value;
   s   := trunc(sgn(dd));
   if (dd=0)and(pos('-',Longedit2.text)>0) then s:=-1;
   dec := dd+s*LongEdit5.Value/60+s*LongEdit9.value/3600;
   la  := LongEdit3.Value+LongEdit6.value/60+LongEdit10.value/3600;
   th:= StrTofloat(Edit7.Text);
//   if th>90 then th:=90;
//   if th<-90 then th:=-90;
   ModalResult := mrOK;
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
ModalResult := mrCancel;
end;

procedure TForm2.FormShow(Sender: TObject);
var  buf,d,m,s : string;
begin
skipaz:=true;
buf:=artostr2(arc,d,m,s);
LongEdit1.Text:=' '+d;
LongEdit4.Text:=m;
LongEdit8.Text:=s;
buf:=detostr2(dec,d,m,s);
LongEdit2.Text:=d;
LongEdit5.Text:=m;
LongEdit9.Text:=s;
buf:=detostr2(la,d,m,s);
LongEdit3.Text:=d;
LongEdit6.Text:=m;
LongEdit10.Text:=s;
str(th:7:3,buf);
Edit7.Text:=buf;
skipaz:=false;
LongEdit1.text:=trim(LongEdit1.text);
end;

procedure TForm2.SpeedButton1Click(Sender: TObject);
begin
Edit7.Text:='0';
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
SetLang;
end;

procedure TForm2.BitBtn3Click(Sender: TObject);
begin
showhelp('doc1.html#coord');
end;

procedure TForm2.LongEdit1Change(Sender: TObject);
var ar,de,dd,s,az,al : double;
    p : integer;
    buf,d,m,ss : string;
begin
if skipaz then exit;
if (trim(LongEdit1.text)='') or
   (trim(LongEdit4.text)='') or
   (trim(LongEdit8.text)='') or
   (trim(LongEdit2.text)='') or
   (trim(LongEdit5.text)='') or
   (trim(LongEdit9.text)='') then exit;
skipaz:=true;
try
ar := LongEdit1.value+LongEdit4.value/60+LongEdit8.value/3600;
dd := LongEdit2.value;
s  := trunc(sgn(dd));
if (dd=0)and(pos('-',Longedit2.text)>0) then s:=-1;
de := dd+s*LongEdit5.Value/60+s*LongEdit9.value/3600;
eq2hz(15*(CurrentST-ar),de,az,al);
if AzNorth then az:=rmod(az+180,360);
buf:=detostr2(az,d,m,ss);
LongEdit7.Text:=d;
LongEdit11.Text:=m;
LongEdit12.Text:=ss;
buf:=detostr2(al,d,m,ss);
LongEdit13.Text:=d;
LongEdit14.Text:=m;
LongEdit15.Text:=ss;
finally
skipaz:=false;
end;
end;

procedure TForm2.LongEdit7Change(Sender: TObject);
var ar,de,dd,s,az,al : double;
    buf,d,m,ss : string;
begin
if skipaz then exit;
if (trim(LongEdit7.text)='') or (trim(LongEdit7.text)='-') or (trim(LongEdit7.text)='+') or
   (trim(LongEdit11.text)='') or (trim(LongEdit11.text)='-') or (trim(LongEdit11.text)='+') or
   (trim(LongEdit13.text)='') or (trim(LongEdit13.text)='-') or (trim(LongEdit13.text)='+') or
   (trim(LongEdit14.text)='') or (trim(LongEdit14.text)='-') or (trim(LongEdit14.text)='+') or
   (trim(LongEdit15.text)='') or (trim(LongEdit15.text)='-') or (trim(LongEdit15.text)='+')
   then exit;
skipaz:=true;
try
az := LongEdit7.value+LongEdit11.value/60+LongEdit12.value/3600;
dd := LongEdit13.value;
s  := trunc(sgn(dd));
if (dd=0)and(pos('-',Longedit13.text)>0) then s:=-1;
al := dd+s*LongEdit14.Value/60+s*LongEdit15.value/3600;
if AzNorth then az:=rmod(az+180,360);
hz2eq(az,al,ar,de);
ar:=rmod(CurrentST-ar/15+24,24);
buf:=artostr2(ar,d,m,ss);
LongEdit1.Text:=d;
LongEdit4.Text:=m;
LongEdit8.Text:=ss;
buf:=detostr2(de,d,m,ss);
LongEdit2.Text:=d;
LongEdit5.Text:=m;
LongEdit9.Text:=ss;
finally
skipaz:=false;
end;
end;

procedure TForm2.LongEdit1Enter(Sender: TObject);
begin
with sender as Tlongedit do selectall;
end;

end.
