unit dssplate;

interface

uses IniFiles,SkyLib,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, Buttons;

type
  TDssPlateList = class(TForm)
    ListBox1: TListBox;
    Label1: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Procedure SetLang;

var
  DssPlateList: TDssPlateList;

implementation

{$R *.DFM}

Procedure SetLang;
var
    inifile : Tmeminifile;
const deftxt = '?';
begin
if language>'0' then begin
inifile:=Tmeminifile.create(AppDir+'\language_'+language+'.ini');
with DssPlateList do
  with inifile do begin
    caption:=ReadString('main','t_69',deftxt);
    BitBtn1.Caption:=ReadString('buttons','ok',deftxt);
    BitBtn2.Caption:=ReadString('buttons','cancel',deftxt);
    BitBtn3.Caption:=ReadString('buttons','help',deftxt);
  end;
inifile.free;
end;
end;

procedure TDssPlateList.FormCreate(Sender: TObject);
begin
SetLang;
end;

procedure TDssPlateList.BitBtn3Click(Sender: TObject);
begin
showhelp('doc1.html#dss');
end;

end.
