unit printscaleUnit;

interface

uses Skylib,IniFiles,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

Procedure SetLang;

type
  TPrintScaleForm = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label6: TLabel;
    BitBtn3: TBitBtn;
    Label7: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  PrintScaleForm: TPrintScaleForm;
  PrinterScale : Double;
implementation

{$R *.DFM}

Procedure SetLang;
var section : string;
    inifile : Tmeminifile;
const deftxt = '?';
begin
if language>'0' then begin
inifile:=Tmeminifile.create(AppDir+'\language_'+language+'.ini');
section:='printscale';
with printscaleForm do
  with inifile do begin
    Label1.Caption:=ReadString(section,'t_1',deftxt);
    Label2.Caption:=ReadString(section,'t_2',deftxt);
    Label3.Caption:=ReadString(section,'t_3',deftxt);
    Label4.Caption:=ReadString(section,'t_4',deftxt);
    Caption:=ReadString(section,'t_5',deftxt);
    Label6.Caption:=ReadString(section,'t_6',deftxt);
    BitBtn1.Caption:=ReadString('buttons','ok',deftxt);
    BitBtn2.Caption:=ReadString('buttons','cancel',deftxt);
    BitBtn3.Caption:=ReadString('buttons','help',deftxt);
  end;
inifile.free;
end;
end;

procedure TPrintScaleForm.Button2Click(Sender: TObject);
begin
ModalResult:=mrCancel;
end;

procedure TPrintScaleForm.Button1Click(Sender: TObject);
begin
PrinterResolution:=strtoint(Edit1.Text);
PrinterScale:=strtofloat(Edit2.Text);
ModalResult:=mrOK;
end;

procedure TPrintScaleForm.FormShow(Sender: TObject);
begin
Edit1.Text:=inttostr(PrinterResolution);
Edit2.Text:=FloattostrF(PrinterScale,ffFixed,5,2);
end;

procedure TPrintScaleForm.FormCreate(Sender: TObject);
begin
SetLang;
end;

procedure TPrintScaleForm.BitBtn3Click(Sender: TObject);
begin
showhelp('doc1.html#echelle');
end;

end.
