library catalog;
{
Copyright (C) 2000 Patrick Chevalley

http://www.astrosurf.org/astropc
pchev@geocities.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

uses
  SysUtils,
  BSCUnit in 'BSCUnit.pas',
  GCVUnit in 'GCVUnit.pas',
  GPNUnit in 'GPNUnit.pas',
  DSCAT in 'DSCAT.pas',
  GSCFITS in 'GSCFITS.pas',
  GSCUnit in 'GSCUnit.pas',
  LBNUnit in 'LBNUnit.pas',
  NGCUnit in 'NGCUnit.pas',
  SACUnit in 'SACUnit.pas',
  OCLUnit in 'OCLUnit.pas',
  PGCUnit in 'PGCUnit.pas',
  GCMUnit in 'GCMUnit.pas',
  skylibcat in 'skylibcat.pas',
  GSCconst in 'gscconst.pas',
  WDSUnit in 'WDSUnit.pas',
  TICUnit in 'TICUnit.pas',
  TYCUnit in 'TYCUnit.pas',
  USNOAUnit in 'USNOAUnit.pas',
  SkyUnit in 'SkyUnit.pas',
  RC3unit in 'RC3unit.pas',
  FindUnit in 'FindUnit.pas',
  microcat in 'microcat.pas',
  TYC2Unit in 'tyc2unit.pas',
  GSCC in 'GSCC.pas',
  GCatUnit in 'GCatUnit.pas';

{$R *.res}

exports
       SetBSCpath   index  130  ,
       OpenBSC      index  129  ,
       OpenBSCwin   index  128  ,
       ReadBSC      index  127  ,
       NextBSC      index  126  ,
       CloseBSC     index  125  ,

       SetSKYpath   index  124  ,
       OpenSKY      index  123  ,
       OpenSKYwin   index  122  ,
       ReadSKY      index  121  ,
       NextSKY      index  120  ,
       CloseSKY     index  119  ,

       SetTYCpath   index   118 ,
       OpenTYC       index  117 ,
       OpenTYCwin    index  116  ,
       ReadTYC       index  115  ,
       NextTYC       index  114  ,
       CloseTYC      index  113  ,

       SetTY2path   index   112 ,
       OpenTY2       index  111  ,
       OpenTY2win    index  110  ,
       ReadTY2       index  109  ,
       NextTY2       index  108  ,
       CloseTY2      index  107  ,

       SetTICpath   index   106 ,
       OpenTIC       index  105  ,
       OpenTICwin    index  104  ,
       ReadTIC       index  103  ,
       NextTIC       index  102  ,
       CloseTIC      index  101  ,

       SetGSCpath   index   100 ,
       OpenGSC       index   99 ,
       OpenGSCwin    index   98 ,
       ReadGSC       index   97 ,
       NextGSC       index   96 ,
       CloseGSC      index   95 ,

       SetGSCFpath   index   94 ,
       OpenGSCF       index  93  ,
       OpenGSCFwin    index  92  ,
       ReadGSCF       index  91  ,
       CloseGSCF      index  90  ,

       SetGSCCpath   index   89 ,
       OpenGSCC       index  88  ,
       OpenGSCCwin    index  87  ,
       ReadGSCC       index  86  ,
       NextGSCC       index  85  ,
       CloseGSCC      index  84  ,

       SetUSNOApath   index 83   ,
       OpenUSNOA     index  82  ,
       OpenUSNOAwin  index  81  ,
       ReadUSNOA     index  80  ,
       CloseUSNOA    index  79  ,

       SetMCTpath   index  78  ,
       OpenMCT     index   77 ,
       OpenMCTwin  index   76 ,
       ReadMCT     index   75 ,
       CloseMCT    index   74 ,

       SetGCVpath   index   73 ,
       OpenGCV       index  72  ,
       OpenGCVwin    index  71  ,
       ReadGCV       index  70  ,
       NextGCV       index  69  ,
       CloseGCV      index  68  ,

       SetWDSpath   index   67 ,
       OpenWDS       index  66  ,
       OpenWDSwin    index  65  ,
       ReadWDS       index  64  ,
       NextWDS       index  63  ,
       CloseWDS      index  62  ,

       SetSACpath   index   61 ,
       OpenSAC       index  60  ,
       OpenSACwin    index  59  ,
       ReadSAC       index  58  ,
       CloseSAC      index  57  ,

       SetNGCpath   index   56 ,
       OpenNGC       index  55  ,
       OpenNGCwin    index  54  ,
       ReadNGC       index  53  ,
       CloseNGC      index  52  ,

       SetLBNpath   index   51 ,
       OpenLBN       index  50  ,
       OpenLBNwin    index  49  ,
       ReadLBN       index  48  ,
       CloseLBN      index  47  ,

       SetRC3path   index   46 ,
       OpenRC3       index  45  ,
       OpenRC3win    index  44  ,
       ReadRC3       index  43  ,
       CloseRC3      index  42  ,

       SetPGCpath   index   41 ,
       OpenPGC       index  40  ,
       OpenPGCwin    index  39  ,
       ReadPGC       index  38  ,
       ClosePGC      index  37  ,

       SetOCLpath   index   36 ,
       OpenOCL       index  35  ,
       OpenOCLwin    index  34  ,
       ReadOCL       index  33  ,
       CloseOCL      index  32  ,

       SetGCMpath   index  31  ,
       OpenGCM       index  30  ,
       OpenGCMwin    index  29  ,
       ReadGCM       index  28  ,
       CloseGCM      index  27  ,

       SetDSpath   index    146 ,
       OpenDSTYC      index   145 ,
       OpenDSTYCwin   index   144 ,
       ReadDSTYC      index   143 ,
       NextDSTYC      index   142 ,
       CloseDSTYC     index   141 ,
       OpenDSGSC      index   140 ,
       OpenDSGSCwin   index   139 ,
       ReadDSGSC      index   138 ,
       NextDSGSC      index   137 ,
       CloseDSGSC     index   136 ,
       OpenDSbase      index  135  ,
       OpenDSbasewin   index  134  ,
       ReadDSbase      index  133  ,
       CloseDSbase     index  132  ,

       SetGCatpath    index  147  ,
       OpenGCat       index  148  ,
       OpenGCatwin    index  149  ,
       ReadGCat       index  150  ,
       CloseGCat      index  151  ,
       GetGCatInfo    index  152  ,
       ReadGCat2      index  176  ,
       NextGCat       index  177  ,

       SetGPNpath   index   26 ,
       OpenGPN       index  25  ,
       OpenGPNwin    index  24  ,
       ReadGPN       index  23  ,
       CloseGPN      index  22  ,
       FindNumNGC    index  21  ,
       FindNumIC     index  20  ,
       FindNumMessier index  19  ,
       FindNumGCVS   index  18  ,
       FindNumGSC    index  17  ,
       FindNumGSCF   index  16  ,
       FindNumGSCC   index  15  ,
       FindNumGC     index  14  ,
       FindNumHR     index  13  ,
       FindNumBayer  index  12  ,
       FindNumFlam   index  11  ,
       FindNumHD     index  10  ,
       FindNumSAO    index  9  ,
       FindNumBD     index  8  ,
       FindNumCD     index  7  ,
       FindNumCPD    index  6  ,
       FindNumPGC    index  5  ,
       FindNumSAC    index  4  ,
       FindNumWDS    index  131  ,
       FindNumGcat   index  178 ,
       FindNumTYC2   index  179 ,
       InitCat      index  3  ,
       SetCatLang   index  2  ,
       InitCatWin   index  1  ,

       IsBSCpath   index  153  ,
       IsSKYpath   index  154 ,
       IsTYCpath   index   155 ,
       IsTY2path   index   156 ,
       IsTICpath   index   157 ,
       IsGSCpath   index   158 ,
       IsGSCFpath   index  159 ,
       IsGSCCpath   index  160 ,
       IsUSNOApath   index 161  ,
       IsMCTpath   index   162,
       IsGCVpath   index   163,
       IsWDSpath   index   164,
       IsSACpath   index   165,
       IsNGCpath   index   166,
       IsLBNpath   index   167,
       IsRC3path   index   168,
       IsPGCpath   index   169,
       IsOCLpath   index   170,
       IsGCMpath   index   171,
       IsGPNpath   index   172,
       IsDSbasepath   index    173,
       IsDStycpath   index    174,
       IsDSgscpath   index    175;


begin
decimalseparator:='.';
end.
