program options;

{$APPTYPE CONSOLE}

uses Registry,sysutils;

var opt,buf,buf1,buf2,appdir : string;
    c : char;
    Registry1 : Tregistry;
    ok,nocheck,useopengl : boolean;
    DefaultPrtRes : integer;
    multiinstance : boolean = false;

begin
appdir:=getcurrentdir;
Registry1 := TRegistry.Create;
writeln(' ');
writeln(' Cartes du Ciel - Sky Charts');
writeln(' ');
writeln(' Use this program to select the following options');
repeat
nocheck:=false;
DefaultPrtRes:=300;
with Registry1 do begin
  ok:=Openkey('Software\Astro_PC\Ciel',false);
  if ValueExists('Multi_Instance') then multiinstance:=ReadBool('Multi_Instance');
  if ValueExists('Install_Dir') then appdir:=ReadString('Install_Dir');
  CloseKey;
  ok:=Openkey('Software\Astro_PC\Ciel\Config',false);
  if ok then begin
     if ValueExists('BypassNetworkCheck') then nocheck := ReadBool('BypassNetworkCheck');
     if ValueExists('DefaultPrtRes') then DefaultPrtRes := ReadInteger('DefaultPrtRes');
  end;
  CloseKey;
end;
if multiinstance then buf:='Yes' else buf:='No';
buf1:=appdir+'\planetrender.dll';
useopengl:=fileexists(buf1);
if useopengl then buf2:='Yes' else buf2:='No';
writeln(' ');
writeln(' 1  Do not control network presence at startup');
writeln(' 2  Control network presence at startup');
writeln(' 3  Reset all default value or uninstall (clear registry)');
writeln(' 4  Default printer resolution, actually : '+inttostr(DefaultPrtRes));
writeln(' 5  Allow multiple instance of the program, actually : '+buf);
writeln(' 6  Allow to use OpenGL to render the planets, actually : '+buf2);
writeln(' q  Quit');
writeln(' ');
if nocheck  then writeln(' Actually network is NOT checked at startup')
            else writeln(' Actually network is checked at startup');
writeln(' ');
write(' ? ');
readln(opt);
opt:=uppercase(opt);
if opt='' then opt:=' ';
c:=opt[1];
case c of
'1' : begin
      nocheck:=true;
      with Registry1 do begin
        ok:=Openkey('Software\Astro_PC\Ciel\Config',true);
        if ok then WriteBool('BypassNetworkCheck',nocheck);
        CloseKey;
      end;
      end;
'2' : begin
      nocheck:=false;
      with Registry1 do begin
        ok:=Openkey('Software\Astro_PC\Ciel\Config',true);
        if ok then WriteBool('BypassNetworkCheck',nocheck);
        CloseKey;
      end;
      end;
'3' : begin
      writeln(' ');
      writeln(' All your customizing for Cartes du Ciel - Sky Charts will be lost.');
      writeln(' Are you sure you want to continue ? (Y/N)');
      writeln(' ');
      write(' ? ');
      readln(opt);
      opt:=uppercase(opt);
      if opt='Y' then begin
      with Registry1 do begin
        ok:=Deletekey('Software\Astro_PC\Ciel\Toolbars\Toolbar97zoom');
        ok:=Deletekey('Software\Astro_PC\Ciel\Toolbars\Toolbar97Visu');
        ok:=Deletekey('Software\Astro_PC\Ciel\Toolbars\Toolbar97Utilit');
        ok:=Deletekey('Software\Astro_PC\Ciel\Toolbars\Toolbar97tools');
        ok:=Deletekey('Software\Astro_PC\Ciel\Toolbars\Toolbar97Scale');
        ok:=Deletekey('Software\Astro_PC\Ciel\Toolbars\Toolbar97Photo');
        ok:=Deletekey('Software\Astro_PC\Ciel\Toolbars');
        ok:=Deletekey('Software\Astro_PC\Ciel\Position');
        ok:=Deletekey('Software\Astro_PC\Ciel\Config');
        ok:=Deletekey('Software\Astro_PC\Ciel\Color');
        ok:=Deletekey('Software\Astro_PC\Ciel\Catalog2');
        ok:=Deletekey('Software\Astro_PC\Ciel\Catalog1');
        ok:=Deletekey('Software\Astro_PC\Ciel\Catalog');
        ok:=Deletekey('Software\Astro_PC\Ciel');
      end;
      writeln(' ');
      writeln(' All registry entries for Cartes du Ciel - Sky Charts are removed');
      end;
      end;
'4' : begin
      writeln(' ');
      writeln(' New default printer resolution :');
      write(' ? ');
      readln(opt);
      DefaultPrtRes:=strtointdef(opt,300);
      with Registry1 do begin
        ok:=Openkey('Software\Astro_PC\Ciel\Config',true);
        if ok then WriteInteger('DefaultPrtRes',DefaultPrtRes);
        CloseKey;
      end;
      end;
'5' : begin
      multiinstance:=not multiinstance;
      with Registry1 do begin
        ok:=Openkey('Software\Astro_PC\Ciel',true);
        if ok then WriteBool('Multi_Instance',multiinstance);
        CloseKey;
      end;
      end;
'6' : begin
      buf2:=changefileext(buf1,'.ogl');
      if useopengl then begin
         deletefile(buf2);
         renamefile(buf1,buf2);
      end else begin
         if fileexists(buf2) then begin
            renamefile(buf2,buf1);
         end else begin
            writeln('File '+buf2+' not found!'+chr(10)+chr(13)+'Please reinstall the basic package.');
         end;
      end;
      end;
end;
until c='Q';
Registry1.Free;
end.
