unit planning1;

interface

uses Mydialog, FileCtrl,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Grids, ExtCtrls, Buttons,Math,
  skylib,orbites,IniFiles,printers,planet1, sky_locate,
  jvGridPrinter, Mask, ToolEdit, EnhEdits, JDCalendar ;

Procedure SetLang;
Procedure RefreshComete;

type
  TPlanningForm = class(TForm)
    PageControl1: TPageControl;
    crepuscule: TTabSheet;
    planetes: TTabSheet;
    StringGrid2: TStringGrid;
    cometes: TTabSheet;
    ComboBox1: TComboBox;
    StringGrid1: TStringGrid;
    Pagecontrol2: TPageControl;
    Mercure: TTabSheet;
    Venus: TTabSheet;
    PLune: TTabSheet;
    Mars: TTabSheet;
    Jupiter: TTabSheet;
    Saturne: TTabSheet;
    Uranus: TTabSheet;
    Neptune: TTabSheet;
    Pluton: TTabSheet;
    PlutonGrid: TStringGrid;
    NeptuneGrid: TStringGrid;
    UranusGrid: TStringGrid;
    SaturneGrid: TStringGrid;
    JupiterGrid: TStringGrid;
    MarsGrid: TStringGrid;
    LuneGrid: TStringGrid;
    VenusGrid: TStringGrid;
    MercureGrid: TStringGrid;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label5: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    BitBtn1: TBitBtn;
    DateTimePicker3: TDateTimePicker;
    Psoleil: TTabSheet;
    SoleilGrid: TStringGrid;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    jvGridPrinter1: TjvGridPrinter;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    Memo1: TMemo;
    Solar: TTabSheet;
    Lunar: TTabSheet;
    SolarGrid: TStringGrid;
    LunarGrid: TStringGrid;
    Satellites: TTabSheet;
    SatGrid: TStringGrid;
    Label6: TLabel;
    maglimit: TFloatEdit;
    Label7: TLabel;
    tle: TEdit;
    SatChartBox: TCheckBox;
    magchart: TFloatEdit;
    Label8: TLabel;
    IridiumBox: TCheckBox;
    TLEListBox: TFileListBox;
    EcliPanel: TPanel;
    SatPanel: TPanel;
    Label9: TLabel;
    TLEBtn: TBitBtn;
    JDCalendar1: TJDCalendar;
    JDCalendar2: TJDCalendar;
    fullday: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure CoordGridMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TLEListBoxExit(Sender: TObject);
    procedure EcliPanelClick(Sender: TObject);
    procedure TLEBtnClick(Sender: TObject);
    procedure SatPanelClick(Sender: TObject);
    procedure Label9Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Type
    TObjCoord = class(Tobject)
                jd,ra,dec : double;
                end;

var
  PlanningForm: TPlanningForm;

Const MonthLst : array [1..12] of string = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');

implementation

{$R *.DFM}

uses
{$IFNDEF CALENDAR}
Sky_P1,
timeskip,
Selcatunit,
{$ELSE}
calendar1,
{$ENDIF}
BigIma;

const maxstep = 100;

var appmsg : array [1..45] of string;
    initial : boolean = true;
    showcomet : boolean = false;
    dat11,dat12,dat13,dat21,dat22,dat23,dat31,dat32,dat33,dat41,dat51,dat61 : double ; dat14,dat24,dat34 : string;
    titre,calobs1,calobs2,calobs3,Siecle_Solar,Siecle_Lunar,tz,east,west : string;
    jdt_ut : double;

Procedure cometetitle;
begin
with planningform.stringgrid1 do begin
cells[9,0]:=appmsg[14];
cells[10,0]:=appmsg[15];
cells[11,0]:=appmsg[14];
cells[12,0]:=appmsg[16];
cells[0,1]:=appmsg[11];
cells[1,1]:=appmsg[1];
cells[2,1]:=appmsg[2];
cells[3,1]:=appmsg[3];
cells[4,1]:=appmsg[17];
cells[5,1]:=appmsg[18];
cells[6,1]:=appmsg[6];
cells[7,1]:=appmsg[7];
cells[8,1]:=appmsg[8];
cells[9,1]:=appmsg[12];
cells[10,1]:=appmsg[13];
cells[11,1]:=appmsg[13];
cells[12,1]:=appmsg[12];
end;
end;

Procedure crepusculetitle;
begin
with planningform.stringgrid2 do begin
cells[1,0]:=appmsg[9];
cells[2,0]:='';
cells[3,0]:=appmsg[10];
cells[4,0]:='';
cells[0,1]:=appmsg[11];
cells[1,1]:=appmsg[12];
cells[2,1]:=appmsg[13];
cells[3,1]:=appmsg[13];
cells[4,1]:=appmsg[12];
end;
end;

Procedure planettitle;
begin
with planningform.Soleilgrid do begin
cells[1,1]:=appmsg[1];
cells[2,1]:=appmsg[2];
cells[3,1]:=appmsg[3];
cells[4,1]:=appmsg[4];
cells[5,1]:=appmsg[5];
cells[6,1]:=appmsg[6];
cells[7,1]:=appmsg[7];
cells[8,1]:=appmsg[8];
cells[9,1]:=appmsg[21];
cells[10,1]:=appmsg[22];
end;
with planningform.Mercuregrid do begin
cells[1,1]:=appmsg[1];
cells[2,1]:=appmsg[2];
cells[3,1]:=appmsg[3];
cells[4,1]:=appmsg[4];
cells[5,1]:=appmsg[5];
cells[6,1]:=appmsg[6];
cells[7,1]:=appmsg[7];
cells[8,1]:=appmsg[8];
cells[9,1]:=appmsg[21];
cells[10,1]:=appmsg[22];
end;
with planningform.venusgrid do begin
cells[1,1]:=appmsg[1];
cells[2,1]:=appmsg[2];
cells[3,1]:=appmsg[3];
cells[4,1]:=appmsg[4];
cells[5,1]:=appmsg[5];
cells[6,1]:=appmsg[6];
cells[7,1]:=appmsg[7];
cells[8,1]:=appmsg[8];
cells[9,1]:=appmsg[21];
cells[10,1]:=appmsg[22];
end;
with planningform.lunegrid do begin
cells[1,1]:=appmsg[1];
cells[2,1]:=appmsg[2];
cells[3,1]:=appmsg[3];
cells[4,1]:=appmsg[4];
cells[5,1]:=appmsg[5];
cells[6,1]:=appmsg[6];
cells[7,1]:=appmsg[7];
cells[8,1]:=appmsg[8];
cells[9,1]:=appmsg[21];
cells[10,1]:=appmsg[22];
end;
with planningform.Marsgrid do begin
cells[1,1]:=appmsg[1];
cells[2,1]:=appmsg[2];
cells[3,1]:=appmsg[3];
cells[4,1]:=appmsg[4];
cells[5,1]:=appmsg[5];
cells[6,1]:=appmsg[6];
cells[7,1]:=appmsg[7];
cells[8,1]:=appmsg[8];
cells[9,1]:=appmsg[21];
cells[10,1]:=appmsg[22];
end;
with planningform.jupitergrid do begin
cells[1,1]:=appmsg[1];
cells[2,1]:=appmsg[2];
cells[3,1]:=appmsg[3];
cells[4,1]:=appmsg[4];
cells[5,1]:=appmsg[5];
cells[6,1]:=appmsg[6];
cells[7,1]:=appmsg[7];
cells[8,1]:=appmsg[8];
cells[9,1]:=appmsg[21];
cells[10,1]:=appmsg[22];
end;
with planningform.saturnegrid do begin
cells[1,1]:=appmsg[1];
cells[2,1]:=appmsg[2];
cells[3,1]:=appmsg[3];
cells[4,1]:=appmsg[4];
cells[5,1]:=appmsg[5];
cells[6,1]:=appmsg[6];
cells[7,1]:=appmsg[7];
cells[8,1]:=appmsg[8];
cells[9,1]:=appmsg[21];
cells[10,1]:=appmsg[22];
end;
with planningform.uranusgrid do begin
cells[1,1]:=appmsg[1];
cells[2,1]:=appmsg[2];
cells[3,1]:=appmsg[3];
cells[4,1]:=appmsg[4];
cells[5,1]:=appmsg[5];
cells[6,1]:=appmsg[6];
cells[7,1]:=appmsg[7];
cells[8,1]:=appmsg[8];
cells[9,1]:=appmsg[21];
cells[10,1]:=appmsg[22];
end;
with planningform.neptunegrid do begin
cells[1,1]:=appmsg[1];
cells[2,1]:=appmsg[2];
cells[3,1]:=appmsg[3];
cells[4,1]:=appmsg[4];
cells[5,1]:=appmsg[5];
cells[6,1]:=appmsg[6];
cells[7,1]:=appmsg[7];
cells[8,1]:=appmsg[8];
cells[9,1]:=appmsg[21];
cells[10,1]:=appmsg[22];
end;
with planningform.plutongrid do begin
cells[1,1]:=appmsg[1];
cells[2,1]:=appmsg[2];
cells[3,1]:=appmsg[3];
cells[4,1]:=appmsg[4];
cells[5,1]:=appmsg[5];
cells[6,1]:=appmsg[6];
cells[7,1]:=appmsg[7];
cells[8,1]:=appmsg[8];
cells[9,1]:=appmsg[21];
cells[10,1]:=appmsg[22];
end;
end;

Procedure Solartitle;
begin
with planningform.solargrid do begin
cells[0,1]:=appmsg[11];
cells[1,0]:=appmsg[23];
cells[1,1]:=appmsg[24];
cells[2,1]:=appmsg[25];
cells[3,1]:=appmsg[26];
cells[4,1]:=appmsg[27];
cells[5,1]:=appmsg[28];
cells[6,0]:=appmsg[29];
cells[6,1]:=appmsg[31];
cells[7,0]:=appmsg[30];
cells[7,1]:=appmsg[32];
cells[8,1]:=appmsg[33];
cells[9,1]:=appmsg[34];
cells[10,1]:=appmsg[35];
end;
end;

Procedure Lunartitle;
begin
with planningform.Lunargrid do begin
cells[0,1]:=appmsg[11];
cells[1,0]:=appmsg[23];
cells[1,1]:=appmsg[24];
cells[2,1]:=appmsg[25];
cells[3,1]:=appmsg[26];
cells[4,1]:=appmsg[27];
cells[5,0]:=appmsg[36];
cells[5,1]:=appmsg[28];
cells[6,0]:=appmsg[37];
cells[6,1]:=appmsg[28];
cells[7,0]:=appmsg[38];
cells[7,1]:=appmsg[40];
cells[8,0]:=appmsg[39];
cells[8,1]:=appmsg[41];
end;
end;

Procedure Sattitle;
begin
with planningform.Satgrid do begin
cells[0,1]:=appmsg[11];
cells[1,1]:=appmsg[42];
cells[2,1]:=appmsg[3];
cells[3,1]:=appmsg[21];
cells[4,1]:=appmsg[22];
cells[5,1]:=appmsg[43];
cells[6,1]:=appmsg[1];
cells[7,1]:=appmsg[2];
cells[8,1]:=appmsg[44];
cells[9,1]:=appmsg[45];
end;
end;

Procedure SetLang;
var section : string;
    inifile : Tmeminifile;
    i : integer;
const blank = '        ';
const deftxt = '?';
begin
if language>'0' then begin
inifile:=Tmeminifile.create(AppDir+'\language_'+language+'.ini');
section:='calendar';
with PlanningForm do
  with inifile do begin
    Caption:=ReadString(section,'title',deftxt);
    label1.caption:=ReadString(section,'t_1',deftxt);
    label2.caption:=ReadString(section,'t_2',deftxt);
    label5.caption:=ReadString(section,'t_3',deftxt);
    label3.caption:=ReadString(section,'t_4',deftxt);
    label4.caption:=ReadString(section,'t_5',deftxt);
    crepuscule.caption:=ReadString(section,'t_6',deftxt);
    planetes.caption:=ReadString(section,'t_7',deftxt);
    cometes.caption:=ReadString(section,'t_8',deftxt);
    solar.caption:=ReadString(section,'t_9',deftxt);
    lunar.caption:=ReadString(section,'t_10',deftxt);
    Satellites.caption:=ReadString(section,'t_11',deftxt);
    label7.caption:=ReadString(section,'t_12',deftxt);
    label8.caption:=ReadString(section,'t_13',deftxt);
    label6.caption:=ReadString(section,'t_14',deftxt);
    SatChartBox.caption:=ReadString(section,'t_15',deftxt);
    IridiumBox.caption:=ReadString(section,'t_16',deftxt);
    TLEbtn.Caption:=ReadString(section,'t_17',deftxt);
    TLEbtn.hint:=ReadString(section,'t_18',deftxt)+' '+slash(appdir)+satpath;
    BitBtn1.Caption:=ReadString('buttons','refresh',deftxt);
    BitBtn2.Caption:=ReadString('buttons','close',deftxt);
    BitBtn3.Caption:=ReadString('buttons','help',deftxt);
    BitBtn4.Caption:=ReadString('buttons','print',deftxt);
    BitBtn5.Caption:=ReadString('main','t_22',deftxt);
    tz:=ReadString('observatory','t_16',deftxt);
    west:=ReadString('observatory','t_12',deftxt);
    east:=ReadString('observatory','t_13',deftxt);
    mercure.caption:=pla[1];
    venus.caption:=pla[2];
    mars.caption:=pla[4];
    jupiter.caption:=pla[5];
    saturne.caption:=pla[6];
    uranus.caption:=pla[7];
    neptune.caption:=pla[8];
    pluton.caption:=pla[9];
    psoleil.caption:=pla[10];
    plune.caption:=pla[11];
    for i:=1 to 45 do begin
       appmsg[i]:=ReadString(section,'m_'+trim(inttostr(i)),deftxt);
    end;
  end;
inifile.free;
end;
titre:=PlanningForm.caption;
crepusculetitle;
cometetitle;
planettitle;
Solartitle;
LunarTitle;
SatTitle;
end;

Procedure InitString;
begin
appmsg[1]:='AR';
appmsg[2]:='DE';
appmsg[3]:='Magn.';
appmsg[4]:='Diam.';
appmsg[5]:='Illum.';
appmsg[6]:='Lever';
appmsg[7]:='Culmination';
appmsg[8]:='Coucher';
appmsg[9]:='Crpuscule du matin';
appmsg[10]:='Crpuscule du soir';
appmsg[11]:='Date';
appmsg[12]:='Astronomique';
appmsg[13]:='Nautique';
appmsg[14]:='Crpuscule';
appmsg[15]:='du matin';
appmsg[16]:='du soir';
appmsg[17]:='Elong.';
appmsg[18]:='Phase';
appmsg[19]:='Attention ! le calcul pour';
appmsg[20]:='dates peut tre trs long';
appmsg[21]:='Az';
appmsg[22]:='Alt';
end;

Procedure RefreshComete;
var i : integer;
begin
with PlanningForm do begin
combobox1.clear;
for i:=0 to comfile.count-1 do combobox1.items.Add(trim(copy(comfile.strings[i],1,pos('|',comfile.strings[i])-1)));
combobox1.itemindex:=0;
StringGrid1.RowCount:=2;
end;
end;

procedure TPlanningForm.FormCreate(Sender: TObject);
var i : integer;
begin
InitString;
SetLang;
combobox1.clear;
for i:=0 to comfile.count-1 do combobox1.Items.Add(trim(copy(comfile.strings[i],1,pos('|',comfile.strings[i])-1)));
combobox1.itemindex:=0;
jdcalendar1.Year:=CurYear;
jdcalendar1.Month:=currentmonth;
jdcalendar1.day:=currentday;
jdcalendar2.JD:=jdcalendar1.JD+5;
datetimepicker3.Time:=timebias/24;
TLEListBox.Directory:=slash(appdir)+satpath;
chdir(appdir);
end;

function isodate(a,m,d : integer) : string;
begin
result:=padzeros(inttostr(a),4)+'-'+padzeros(inttostr(m),2)+'-'+padzeros(inttostr(d),2);
end;

Procedure FreeCoord(var gr : Tstringgrid);
var i,j : integer;
begin
try
if gr<>nil then with gr as Tstringgrid do
  if rowcount>=3 then
    for i:=2 to rowcount-1 do
      for j:=0 to colcount-1 do
        if Objects[j,i]<>nil then Objects[j,i].Free;
except
//showmessage('freecord :'+gr.Name+' '+inttostr(i)+' '+inttostr(j));
  gr.Cells[0,0]:='';
end;
end;

function SetObjCoord(jd,ra,dec: double) : Tobject;
var p : TObjCoord;
begin
  p:=TObjCoord.Create;
  p.jd:=jd;
  p.ra:=ra;
  p.dec:=dec;
  result:=p;
end;

procedure crepuslist;
var jda,jd0,jd1,jd2,h : double;
    hp1,hp2,ars,des,dist,diam :Double;
    a,m,d,s,i,nj,ierr : integer;
begin
screen.cursor:=crHourglass;
calobs1:=obsnom;
PlanningForm.caption:=titre+' '+Obsnom;
try
with planningform do begin
Stringgrid2.Visible:=false;
FreeCoord(Stringgrid2);
dat11:=jdcalendar1.JD;
dat12:=jdcalendar2.JD;
dat13:=datetimepicker3.datetime;
dat14:=edit1.text;
s:=strtoint(edit1.text);
a:=jdcalendar1.year;
m:=jdcalendar1.month;
d:=jdcalendar1.day;
h:=12-timebias;
jd1:=jd(a,m,d,h);
a:=jdcalendar2.year;
m:=jdcalendar2.month;
d:=jdcalendar2.day;
jd2:=jd(a,m,d,h);
nj:=round((jd2-jd1)/s);
if nj>maxstep then if MyMessageDlg(appmsg[19]+' '+inttostr(nj)+' '+appmsg[20],
    mtConfirmation,[mbOk, mbCancel], 0) <> mrOK then exit;
jda:=jd1;
i:=2;
repeat
djd(jda,a,m,d,h);
jd0:=jd(a,m,d,0);
with stringgrid2 do begin
  RowCount:=i+1;
  cells[0,i]:=isodate(a,m,d);
  Soleil(jd0+0.5,ars,des,dist,diam,ierr);
  if (ars<0) then ars:=ars+24;
  objects[0,i]:=SetObjCoord(jda,-999,-999);
  // crepuscule nautique
  HeurePo(jd0,15*ars,des,-12,hp1,hp2);
  if hp1>-99 then begin
     cells[2,i]:=armtostr(rmod(hp1+timebias+24,24));
     objects[2,i]:=SetObjCoord(jda+(hp1-h)/24,-999,-999);
  end else  begin
     cells[2,i]:='-';
     objects[2,i]:=nil;
  end;
  if hp1>-99 then begin
     cells[3,i]:=armtostr(rmod(hp2+timebias+24,24));
     objects[3,i]:=SetObjCoord(jda+(hp2-h)/24,-999,-999);
  end else  begin
     cells[3,i]:='-';
     objects[3,i]:=nil;
  end;
  // crepuscule astro
  HeurePo(jd0,15*ars,des,-18,hp1,hp2);
  if hp1>-99 then begin
     cells[1,i]:=armtostr(rmod(hp1+timebias+24,24));
     objects[1,i]:=SetObjCoord(jda+(hp1-h)/24,-999,-999);
  end else begin
     cells[1,i]:='-';
     objects[1,i]:=nil;
  end;
  if hp1>-99 then begin
     cells[4,i]:=armtostr(rmod(hp2+timebias+24,24));
     objects[4,i]:=SetObjCoord(jda+(hp2-h)/24,-999,-999);
  end else begin
     cells[4,i]:='-';
     objects[4,i]:=nil;
  end;
end;
jda:=jda+s;
i:=i+1;
until jda>jd2;
end;
finally
Planningform.Stringgrid2.Visible:=true;
screen.cursor:=crDefault;
end;
end;

procedure cometelist;
var buf : string;
    jda,jd0,jd1,jd2,jdt,h,st : double;
    ar,de,dist,r,elong,phase,magn,diam,lc,car,cde : double;
    hr,ht,hs,azr,azs,hp1,hp2,ars,des,ds,dds,az,ha :Double;
    a,m,d,s,i,irc,nj,irc2,ierr : integer;
    hr1,ht1,hs1,hr2,ht2,hs2 : double;
begin
screen.cursor:=crHourGlass;
calobs3:=obsnom;
PlanningForm.caption:=titre+' '+Obsnom;
try
with planningform do begin
stringgrid1.Visible:=false;
FreeCoord(stringgrid1);
showcomet:=true;
dat31:=jdcalendar1.jd;
dat32:=jdcalendar2.jd;
dat33:=datetimepicker3.datetime;
dat34:=edit1.text;
s:=strtoint(edit1.text);
a:=jdcalendar1.year;
m:=jdcalendar1.month;
d:=jdcalendar1.day;
h:=frac(DateTimePicker3.time)*24-timebias;
jd1:=jd(a,m,d,h);
a:=jdcalendar2.year;
m:=jdcalendar2.month;
d:=jdcalendar2.day;
jd2:=jd(a,m,d,h);
nj:=round((jd2-jd1)/s);
if nj>maxstep then if MyMessageDlg(appmsg[19]+' '+inttostr(nj)+' '+appmsg[20],
    mtConfirmation,[mbOk, mbCancel], 0) <> mrOK then exit;
initcomete(combobox1.itemindex,buf);
jda:=jd1;
i:=2;
stringgrid1.cells[0,0]:=trim(armtostr(h))+' UT';
repeat
Comete(jda,ar,de,dist,r,elong,phase,magn,diam,lc,car,cde);
djd(jda,a,m,d,h);
jd0:=jd(a,m,d,0);
with stringgrid1 do begin
  RowCount:=i+1;
  cells[0,i]:=isodate(a,m,d);
  cells[1,i]:=artostr(ar);
  cells[2,i]:=detostr(de);
  cells[3,i]:=floattostrf(magn,ffFixed,5,1);
  cells[4,i]:=demtostr(elong);
  cells[5,i]:=demtostr(phase);
  objects[0,i]:=SetObjCoord(jda,ar,de);
  RiseSet(1,jd0,ar,de,hr1,ht1,hs1,azr,azs,irc);
  Comete(jd0+rmod((hr1-timebias)+24,24)/24,ar,de,dist,r,elong,phase,magn,diam,lc,car,cde);
  RiseSet(1,jd0,ar,de,hr,ht2,hs2,azr,azs,irc2);
  Comete(jd0+rmod((ht1-timebias)+24,24)/24,ar,de,dist,r,elong,phase,magn,diam,lc,car,cde);
  RiseSet(1,jd0,ar,de,hr2,ht,hs2,azr,azs,irc2);
  Comete(jd0+rmod((hs1-timebias)+24,24)/24,ar,de,dist,r,elong,phase,magn,diam,lc,car,cde);
  RiseSet(1,jd0,ar,de,hr2,ht2,hs,azr,azs,irc2);
  case irc of
       0 : begin
           cells[6,i]:=armtostr(hr);
           cells[7,i]:=armtostr(ht);
           cells[8,i]:=armtostr(hs);
           objects[6,i]:=SetObjCoord(jda+(hr-timebias-h)/24,ar,de);
           objects[7,i]:=SetObjCoord(jda+(ht-timebias-h)/24,ar,de);
           objects[8,i]:=SetObjCoord(jda+(hs-timebias-h)/24,ar,de);
           end;
       1 : begin
           cells[6,i]:='-';
           cells[7,i]:=armtostr(ht);
           objects[7,i]:=SetObjCoord(jda+(ht-timebias-h)/24,ar,de);
           cells[8,i]:='-';
           objects[6,i]:=nil;
           objects[8,i]:=nil;
           end;
       2 : begin
           cells[6,i]:='-';
           cells[7,i]:='-';
           cells[8,i]:='-';
           objects[6,i]:=nil;
           objects[7,i]:=nil;
           objects[8,i]:=nil;
           end;
  end;
  Soleil(jda,ars,des,ds,dds,ierr);
  // crepuscule nautique
  HeurePo(jd0,15*ars,des,-12,hp1,hp2);
  if hp1>-99 then begin
  jdt:=jd(a,m,d,hp1);
  Comete(jdt,ar,de,dist,r,elong,phase,magn,diam,lc,car,cde);
  st := Sidtim(jd0,hp1,Obslongitude);
  Horizontal((st-ar)*15,de,az,ha);
  if AzNorth then az:=rmod(az+180,360);
  if ha>0 then cells[10,i]:=dedtostr(ha)+'  '+StringReplace(dedtostr(az),'+','Az',[])
          else cells[10,i]:=dedtostr(ha);
  objects[10,i]:=SetObjCoord(jdt,ar,de);
  end else begin
    cells[10,i]:='-';
    objects[10,i]:=nil;
  end;
  if hp2>-99 then begin
  jdt:=jd(a,m,d,hp2);
  Comete(jdt,ar,de,dist,r,elong,phase,magn,diam,lc,car,cde);
  st := Sidtim(jd0,hp2,Obslongitude);
  Horizontal((st-ar)*15,de,az,ha);
  if AzNorth then az:=rmod(az+180,360);
  if ha>0 then cells[11,i]:=dedtostr(ha)+'  '+StringReplace(dedtostr(az),'+','Az',[])
          else cells[11,i]:=dedtostr(ha);
  objects[11,i]:=SetObjCoord(jdt,ar,de);
  end else begin
    cells[11,i]:='-';
    objects[11,i]:=nil;
  end;
  // crepuscule astro
  HeurePo(jd0,15*ars,des,-18,hp1,hp2);
  if hp2>-99 then begin
  jdt:=jd(a,m,d,hp1);
  Comete(jdt,ar,de,dist,r,elong,phase,magn,diam,lc,car,cde);
  st := Sidtim(jd0,hp1,Obslongitude);
  Horizontal((st-ar)*15,de,az,ha);
  if AzNorth then az:=rmod(az+180,360);
  if ha>0 then cells[9,i]:=dedtostr(ha)+'  '+StringReplace(dedtostr(az),'+','Az',[])
          else cells[9,i]:=dedtostr(ha);
  objects[9,i]:=SetObjCoord(jdt,ar,de);
  end else begin
     cells[9,i]:='-';
     objects[9,i]:=nil;
  end;
  if hp2>-99 then begin
  jdt:=jd(a,m,d,hp2);
  Comete(jdt,ar,de,dist,r,elong,phase,magn,diam,lc,car,cde);
  st := Sidtim(jd0,hp2,Obslongitude);
  Horizontal((st-ar)*15,de,az,ha);
  if AzNorth then az:=rmod(az+180,360);
  if ha>0 then cells[12,i]:=dedtostr(ha)+'  '+StringReplace(dedtostr(az),'+','Az',[])
          else cells[12,i]:=dedtostr(ha);
  objects[12,i]:=SetObjCoord(jdt,ar,de);
  end else begin
     cells[12,i]:='-';
     objects[12,i]:=nil;
  end;
end;
jda:=jda+s;
i:=i+1;
until jda>jd2;
end;
finally
Planningform.stringgrid1.Visible:=true;
screen.cursor:=crDefault;
end;
end;

Procedure InitRiseCell(var gr : Tstringgrid);
var i : integer;
begin
with gr do
    for i:=2 to rowcount-1 do begin
        cells[6,i]:=''; cells[7,i]:=''; cells[8,i]:='';
        end;
end;

Procedure PlanetRiseCell(var gr : Tstringgrid; i,irc : integer; hr,ht,hs,azr,azs,jda,h,ar,de : double);
var ir,ic,it : integer;
    jdcor : double;
begin
with gr do begin
  ir:=i;
  jdcor:=0;
  if hr<0 then begin ir:=i-1 ; hr:=hr+24; jdcor:=-1; end;
  if hr>24 then begin ir:=i+1; hr:=hr-24; jdcor:=1; end;
  it:=i;
  if ht<0 then begin  it:=i-1; ht:=ht+24; jdcor:=-1; end;
  if ht>24 then begin it:=i+1; ht:=ht-24; jdcor:=1; end;
  ic:=i;
  if hs<0 then begin ic:=i-1; hs:=hs+24; jdcor:=-1; end;
  if hs>24 then begin ic:=i+1; hs:=hs-24; jdcor:=-1; end;
  case irc of
       0 : begin
           if (ir>1)and(ir<rowcount) then cells[6,ir]:=armtostr(hr);
           if (it>1)and(it<rowcount) then cells[7,it]:=armtostr(ht);
           if (ic>1)and(ic<rowcount) then cells[8,ic]:=armtostr(hs);
           objects[6,ir]:=SetObjCoord(jda+jdcor+(hr-timebias-h)/24,ar,de);
           objects[7,it]:=SetObjCoord(jda+jdcor+(ht-timebias-h)/24,ar,de);
           objects[8,ic]:=SetObjCoord(jda+jdcor+(hs-timebias-h)/24,ar,de);
           end;
       1 : begin
           if (ir>1)and(ir<rowcount) then cells[6,ir]:='-';
           if (it>1)and(it<rowcount) then cells[7,it]:=armtostr(ht);
           if (ic>1)and(ic<rowcount) then cells[8,ic]:='-';
           objects[7,ir].free;
           objects[7,it]:=SetObjCoord(jda+jdcor+(ht-timebias-h)/24,ar,de);
           objects[7,ic].free;
           end;
       2 : begin
           if (ir>1)and(ir<rowcount) then cells[6,ir]:='-';
           if (it>1)and(it<rowcount) then cells[7,it]:='-';
           if (ic>1)and(ic<rowcount) then cells[8,ic]:='-';
           objects[7,ir].free;
           objects[7,it].free;
           objects[7,ic].free;
           end;
  end;
end;
end;

procedure Planetlist;
var ar,de,dist,illum,phase,diam,jda,magn,dkm,q,az,ha,dp : double;
    err,i,ipla,nj: integer;
    s,a,m,d,irc,ierr : integer;
    jd1,jd2,jd0,h,hr,ht,hs,azr,azs,st0,jdcor : double;
    am1,am2,dm1,dm2,am3,dm3 : double;
    mr,mt,ms : string;
begin
screen.cursor:=crHourGlass;
calobs2:=obsnom;
PlanningForm.caption:=titre+' '+Obsnom;
try
with planningform do begin
SoleilGrid.Visible:=false;
MercureGrid.Visible:=false;
VenusGrid.Visible:=false;
LuneGrid.Visible:=false;
MarsGrid.Visible:=false;
JupiterGrid.Visible:=false;
SaturneGrid.Visible:=false;
UranusGrid.Visible:=false;
NeptuneGrid.Visible:=false;
PlutonGrid.Visible:=false;
dat21:=jdcalendar1.JD;
dat22:=jdcalendar2.JD;
dat23:=datetimepicker3.datetime;
dat24:=edit1.text;
s:=strtoint(edit1.text);
a:=jdcalendar1.year;
m:=jdcalendar1.month;
d:=jdcalendar1.day;
h:=frac(DateTimePicker3.time)*24-timebias;
jd1:=jd(a,m,d,h);
a:=jdcalendar2.year;
m:=jdcalendar2.month;
d:=jdcalendar2.day;
jd2:=jd(a,m,d,h);
nj:=round((jd2-jd1)/s);
if nj>maxstep then if MyMessageDlg(appmsg[19]+' '+inttostr(nj)+' '+appmsg[20],
    mtConfirmation,[mbOk, mbCancel], 0) <> mrOK then exit;
jda:=jd1;
i:=2;
InitRiseCell(SoleilGrid);
InitRiseCell(MercureGrid);
InitRiseCell(VenusGrid);
InitRiseCell(LuneGrid);
InitRiseCell(MarsGrid);
InitRiseCell(JupiterGrid);
InitRiseCell(SaturneGrid);
InitRiseCell(UranusGrid);
InitRiseCell(NeptuneGrid);
InitRiseCell(PlutonGrid);
FreeCoord(SoleilGrid);
FreeCoord(MercureGrid);
FreeCoord(VenusGrid);
FreeCoord(LuneGrid);
FreeCoord(MarsGrid);
FreeCoord(JupiterGrid);
FreeCoord(SaturneGrid);
FreeCoord(UranusGrid);
FreeCoord(NeptuneGrid);
FreeCoord(PlutonGrid);
repeat
djd(jda,a,m,d,h);
jd0:=jd(a,m,d,0);
jDT_UT:=DTminusUT(a)/24;
st0:=SidTim(jd0,h,ObsLongitude);
for ipla:=1 to 11 do begin
 if ipla=3 then continue;
case ipla of
 1 : with Mercuregrid do begin
  Planet(ipla,jda+jdt_ut,ar,de,dist,illum,phase,diam,magn,dp,err);
  if PlanetParalaxe then Paralaxe(st0,dist,ar,de,ar,de,q);
  objects[0,i]:=SetObjCoord(jda,ar,de);
  Horizontal((st0-ar)*15,de,az,ha);
  if AzNorth then az:=rmod(az+180,360);
  RowCount:=i+1;
  cells[0,0]:=pla[ipla];
  cells[0,1]:=trim(armtostr(h))+' UT';
  cells[0,i]:=isodate(a,m,d);
  cells[1,i]:=artostr(ar);
  cells[2,i]:=detostr(de);
  cells[3,i]:=floattostrf(magn,ffFixed,5,1);
  cells[4,i]:=floattostrf(diam,ffFixed,6,1);
  cells[5,i]:=floattostrf(illum,ffFixed,6,2);
  cells[9,i]:=demtostr(az);
  cells[10,i]:=demtostr(ha);
  RiseSet(1,jd0,ar,de,hr,ht,hs,azr,azs,irc);
  case irc of
       0 : begin
           cells[6,i]:=armtostr(hr); cells[7,i]:=armtostr(ht); cells[8,i]:=armtostr(hs);
           objects[6,i]:=SetObjCoord(jda+(hr-timebias-h)/24,ar,de);
           objects[7,i]:=SetObjCoord(jda+(ht-timebias-h)/24,ar,de);
           objects[8,i]:=SetObjCoord(jda+(hs-timebias-h)/24,ar,de);
           end;
       1 : begin
           cells[6,i]:='-'; cells[7,i]:=armtostr(ht); cells[8,i]:='-';
           objects[6,i]:=nil;
           objects[7,i]:=SetObjCoord(jda+(ht-timebias-h)/24,ar,de);
           objects[8,i]:=nil;
           end;
       2 : begin
           cells[6,i]:='-'; cells[7,i]:='-'; cells[8,i]:='-';
           objects[6,i]:=nil;
           objects[7,i]:=nil;
           objects[8,i]:=nil;
           end;
  end;
 end;
 2 : with Venusgrid do begin
  Planet(ipla,jda+jdt_ut,ar,de,dist,illum,phase,diam,magn,dp,err);
  if PlanetParalaxe then Paralaxe(st0,dist,ar,de,ar,de,q);
  objects[0,i]:=SetObjCoord(jda,ar,de);
  Horizontal((st0-ar)*15,de,az,ha);
  if AzNorth then az:=rmod(az+180,360);
  RowCount:=i+1;
  cells[0,0]:=pla[ipla];
  cells[0,1]:=trim(armtostr(h))+' UT';
  cells[0,i]:=isodate(a,m,d);
  cells[1,i]:=artostr(ar);
  cells[2,i]:=detostr(de);
  cells[3,i]:=floattostrf(magn,ffFixed,5,1);
  cells[4,i]:=floattostrf(diam,ffFixed,6,1);
  cells[5,i]:=floattostrf(illum,ffFixed,6,2);
  cells[9,i]:=demtostr(az);
  cells[10,i]:=demtostr(ha);
  RiseSet(1,jd0,ar,de,hr,ht,hs,azr,azs,irc);
  case irc of
       0 : begin
           cells[6,i]:=armtostr(hr); cells[7,i]:=armtostr(ht); cells[8,i]:=armtostr(hs);
           objects[6,i]:=SetObjCoord(jda+(hr-timebias-h)/24,ar,de);
           objects[7,i]:=SetObjCoord(jda+(ht-timebias-h)/24,ar,de);
           objects[8,i]:=SetObjCoord(jda+(hs-timebias-h)/24,ar,de);
           end;
       1 : begin
           cells[6,i]:='-'; cells[7,i]:=armtostr(ht); cells[8,i]:='-';
           objects[7,i]:=SetObjCoord(jda+(ht-timebias-h)/24,ar,de);
           objects[6,i]:=nil;
           objects[8,i]:=nil;
           end;
       2 : begin
           cells[6,i]:='-'; cells[7,i]:='-'; cells[8,i]:='-';
           objects[6,i]:=nil;
           objects[7,i]:=nil;
           objects[8,i]:=nil;
           end;
  end;
 end;
 4 : with Marsgrid do begin
  Planet(ipla,jda+jdt_ut,ar,de,dist,illum,phase,diam,magn,dp,err);
  if PlanetParalaxe then Paralaxe(st0,dist,ar,de,ar,de,q);
  objects[0,i]:=SetObjCoord(jda,ar,de);
  Horizontal((st0-ar)*15,de,az,ha);
  if AzNorth then az:=rmod(az+180,360);
  RowCount:=i+1;
  cells[0,0]:=pla[ipla];
  cells[0,1]:=trim(armtostr(h))+' UT';
  cells[0,i]:=isodate(a,m,d);
  cells[1,i]:=artostr(ar);
  cells[2,i]:=detostr(de);
  cells[3,i]:=floattostrf(magn,ffFixed,5,1);
  cells[4,i]:=floattostrf(diam,ffFixed,6,1);
  cells[5,i]:=floattostrf(illum,ffFixed,6,2);
  cells[9,i]:=demtostr(az);
  cells[10,i]:=demtostr(ha);
  RiseSet(1,jd0,ar,de,hr,ht,hs,azr,azs,irc);
  case irc of
       0 : begin
           cells[6,i]:=armtostr(hr); cells[7,i]:=armtostr(ht); cells[8,i]:=armtostr(hs);
           objects[6,i]:=SetObjCoord(jda+(hr-timebias-h)/24,ar,de);
           objects[7,i]:=SetObjCoord(jda+(ht-timebias-h)/24,ar,de);
           objects[8,i]:=SetObjCoord(jda+(hs-timebias-h)/24,ar,de);
           end;
       1 : begin
           cells[6,i]:='-'; cells[7,i]:=armtostr(ht); cells[8,i]:='-';
           objects[7,i]:=SetObjCoord(jda+(ht-timebias-h)/24,ar,de);
           objects[6,i]:=nil;
           objects[8,i]:=nil;
           end;
       2 : begin
           cells[6,i]:='-'; cells[7,i]:='-'; cells[8,i]:='-';
           objects[6,i]:=nil;
           objects[7,i]:=nil;
           objects[8,i]:=nil;
           end;
  end;
 end;
 5 : with Jupitergrid do begin
  Planet(ipla,jda+jdt_ut,ar,de,dist,illum,phase,diam,magn,dp,err);
  if PlanetParalaxe then Paralaxe(st0,dist,ar,de,ar,de,q);
  objects[0,i]:=SetObjCoord(jda,ar,de);
  Horizontal((st0-ar)*15,de,az,ha);
  if AzNorth then az:=rmod(az+180,360);
  RowCount:=i+1;
  cells[0,0]:=pla[ipla];
  cells[0,1]:=trim(armtostr(h))+' UT';
  cells[0,i]:=isodate(a,m,d);
  cells[1,i]:=artostr(ar);
  cells[2,i]:=detostr(de);
  cells[3,i]:=floattostrf(magn,ffFixed,5,1);
  cells[4,i]:=floattostrf(diam,ffFixed,6,1);
  cells[5,i]:=floattostrf(illum,ffFixed,6,2);
  cells[9,i]:=demtostr(az);
  cells[10,i]:=demtostr(ha);
  RiseSet(1,jd0,ar,de,hr,ht,hs,azr,azs,irc);
  case irc of
       0 : begin
           cells[6,i]:=armtostr(hr); cells[7,i]:=armtostr(ht); cells[8,i]:=armtostr(hs);
           objects[6,i]:=SetObjCoord(jda+(hr-timebias-h)/24,ar,de);
           objects[7,i]:=SetObjCoord(jda+(ht-timebias-h)/24,ar,de);
           objects[8,i]:=SetObjCoord(jda+(hs-timebias-h)/24,ar,de);
           end;
       1 : begin
           cells[6,i]:='-'; cells[7,i]:=armtostr(ht); cells[8,i]:='-';
           objects[7,i]:=SetObjCoord(jda+(ht-timebias-h)/24,ar,de);
           objects[6,i]:=nil;
           objects[8,i]:=nil;
           end;
       2 : begin
           cells[6,i]:='-'; cells[7,i]:='-'; cells[8,i]:='-';
           objects[6,i]:=nil;
           objects[7,i]:=nil;
           objects[8,i]:=nil;
           end;
  end;
 end;
 6 : with Saturnegrid do begin
  Planet(ipla,jda+jdt_ut,ar,de,dist,illum,phase,diam,magn,dp,err);
  if PlanetParalaxe then Paralaxe(st0,dist,ar,de,ar,de,q);
  objects[0,i]:=SetObjCoord(jda,ar,de);
  Horizontal((st0-ar)*15,de,az,ha);
  if AzNorth then az:=rmod(az+180,360);
  RowCount:=i+1;
  cells[0,0]:=pla[ipla];
  cells[0,1]:=trim(armtostr(h))+' UT';
  cells[0,i]:=isodate(a,m,d);
  cells[1,i]:=artostr(ar);
  cells[2,i]:=detostr(de);
  cells[3,i]:=floattostrf(magn,ffFixed,5,1);
  cells[4,i]:=floattostrf(diam,ffFixed,6,1);
  cells[5,i]:=floattostrf(illum,ffFixed,6,2);
  cells[9,i]:=demtostr(az);
  cells[10,i]:=demtostr(ha);
  RiseSet(1,jd0,ar,de,hr,ht,hs,azr,azs,irc);
  case irc of
       0 : begin
           cells[6,i]:=armtostr(hr); cells[7,i]:=armtostr(ht); cells[8,i]:=armtostr(hs);
           objects[6,i]:=SetObjCoord(jda+(hr-timebias-h)/24,ar,de);
           objects[7,i]:=SetObjCoord(jda+(ht-timebias-h)/24,ar,de);
           objects[8,i]:=SetObjCoord(jda+(hs-timebias-h)/24,ar,de);
           end;
       1 : begin
           cells[6,i]:='-'; cells[7,i]:=armtostr(ht); cells[8,i]:='-';
           objects[7,i]:=SetObjCoord(jda+(ht-timebias-h)/24,ar,de);
           objects[6,i]:=nil;
           objects[8,i]:=nil;
           end;
       2 : begin
           cells[6,i]:='-'; cells[7,i]:='-'; cells[8,i]:='-';
           objects[6,i]:=nil;
           objects[7,i]:=nil;
           objects[8,i]:=nil;
           end;
  end;
 end;
 7 : with Uranusgrid do begin
  Planet(ipla,jda+jdt_ut,ar,de,dist,illum,phase,diam,magn,dp,err);
  if PlanetParalaxe then Paralaxe(st0,dist,ar,de,ar,de,q);
  objects[0,i]:=SetObjCoord(jda,ar,de);
  Horizontal((st0-ar)*15,de,az,ha);
  if AzNorth then az:=rmod(az+180,360);
  RowCount:=i+1;
  cells[0,0]:=pla[ipla];
  cells[0,1]:=trim(armtostr(h))+' UT';
  cells[0,i]:=isodate(a,m,d);
  cells[1,i]:=artostr(ar);
  cells[2,i]:=detostr(de);
  cells[3,i]:=floattostrf(magn,ffFixed,5,1);
  cells[4,i]:=floattostrf(diam,ffFixed,6,1);
  cells[5,i]:=floattostrf(illum,ffFixed,6,2);
  cells[9,i]:=demtostr(az);
  cells[10,i]:=demtostr(ha);
  RiseSet(1,jd0,ar,de,hr,ht,hs,azr,azs,irc);
  case irc of
       0 : begin
           cells[6,i]:=armtostr(hr); cells[7,i]:=armtostr(ht); cells[8,i]:=armtostr(hs);
           objects[6,i]:=SetObjCoord(jda+(hr-timebias-h)/24,ar,de);
           objects[7,i]:=SetObjCoord(jda+(ht-timebias-h)/24,ar,de);
           objects[8,i]:=SetObjCoord(jda+(hs-timebias-h)/24,ar,de);
           end;
       1 : begin
           cells[6,i]:='-'; cells[7,i]:=armtostr(ht); cells[8,i]:='-';
           objects[7,i]:=SetObjCoord(jda+(ht-timebias-h)/24,ar,de);
           objects[6,i]:=nil;
           objects[8,i]:=nil;
           end;
       2 : begin
           cells[6,i]:='-'; cells[7,i]:='-'; cells[8,i]:='-';
           objects[6,i]:=nil;
           objects[7,i]:=nil;
           objects[8,i]:=nil;
           end;
  end;
 end;
 8 : with Neptunegrid do begin
  Planet(ipla,jda+jdt_ut,ar,de,dist,illum,phase,diam,magn,dp,err);
  if PlanetParalaxe then Paralaxe(st0,dist,ar,de,ar,de,q);
  objects[0,i]:=SetObjCoord(jda,ar,de);
  Horizontal((st0-ar)*15,de,az,ha);
  if AzNorth then az:=rmod(az+180,360);
  RowCount:=i+1;
  cells[0,0]:=pla[ipla];
  cells[0,1]:=trim(armtostr(h))+' UT';
  cells[0,i]:=isodate(a,m,d);
  cells[1,i]:=artostr(ar);
  cells[2,i]:=detostr(de);
  cells[3,i]:=floattostrf(magn,ffFixed,5,1);
  cells[4,i]:=floattostrf(diam,ffFixed,6,1);
  cells[5,i]:=floattostrf(illum,ffFixed,6,2);
  cells[9,i]:=demtostr(az);
  cells[10,i]:=demtostr(ha);
  RiseSet(1,jd0,ar,de,hr,ht,hs,azr,azs,irc);
  case irc of
       0 : begin
           cells[6,i]:=armtostr(hr); cells[7,i]:=armtostr(ht); cells[8,i]:=armtostr(hs);
           objects[6,i]:=SetObjCoord(jda+(hr-timebias-h)/24,ar,de);
           objects[7,i]:=SetObjCoord(jda+(ht-timebias-h)/24,ar,de);
           objects[8,i]:=SetObjCoord(jda+(hs-timebias-h)/24,ar,de);
           end;
       1 : begin
           cells[6,i]:='-'; cells[7,i]:=armtostr(ht); cells[8,i]:='-';
           objects[7,i]:=SetObjCoord(jda+(ht-timebias-h)/24,ar,de);
           objects[6,i]:=nil;
           objects[8,i]:=nil;
           end;
       2 : begin
           cells[6,i]:='-'; cells[7,i]:='-'; cells[8,i]:='-';
           objects[6,i]:=nil;
           objects[7,i]:=nil;
           objects[8,i]:=nil;
           end;
  end;
 end;
 9 : with Plutongrid do begin
  Planet(ipla,jda+jdt_ut,ar,de,dist,illum,phase,diam,magn,dp,err);
  if PlanetParalaxe then Paralaxe(st0,dist,ar,de,ar,de,q);
  objects[0,i]:=SetObjCoord(jda,ar,de);
  Horizontal((st0-ar)*15,de,az,ha);
  if AzNorth then az:=rmod(az+180,360);
  RowCount:=i+1;
  cells[0,0]:=pla[ipla];
  cells[0,1]:=trim(armtostr(h))+' UT';
  cells[0,i]:=isodate(a,m,d);
  cells[1,i]:=artostr(ar);
  cells[2,i]:=detostr(de);
  cells[3,i]:=floattostrf(magn,ffFixed,5,1);
  cells[4,i]:=floattostrf(diam,ffFixed,6,1);
  cells[5,i]:=floattostrf(illum,ffFixed,6,2);
  cells[9,i]:=demtostr(az);
  cells[10,i]:=demtostr(ha);
  RiseSet(1,jd0,ar,de,hr,ht,hs,azr,azs,irc);
  case irc of
       0 : begin
           cells[6,i]:=armtostr(hr); cells[7,i]:=armtostr(ht); cells[8,i]:=armtostr(hs);
           objects[6,i]:=SetObjCoord(jda+(hr-timebias-h)/24,ar,de);
           objects[7,i]:=SetObjCoord(jda+(ht-timebias-h)/24,ar,de);
           objects[8,i]:=SetObjCoord(jda+(hs-timebias-h)/24,ar,de);
           end;
       1 : begin
           cells[6,i]:='-'; cells[7,i]:=armtostr(ht); cells[8,i]:='-';
           objects[7,i]:=SetObjCoord(jda+(ht-timebias-h)/24,ar,de);
           objects[6,i]:=nil;
           objects[8,i]:=nil;
          end;
       2 : begin
           cells[6,i]:='-'; cells[7,i]:='-'; cells[8,i]:='-';
           objects[6,i]:=nil;
           objects[7,i]:=nil;
           objects[8,i]:=nil;
           end;
  end;
 end;
10 : with Soleilgrid do begin
  Soleil(jda+jdt_ut,ar,de,dist,diam,ierr);
  if PlanetParalaxe then Paralaxe(st0,dist,ar,de,ar,de,q);
  objects[0,i]:=SetObjCoord(jda,ar,de);
  Horizontal((st0-ar)*15,de,az,ha);
  if AzNorth then az:=rmod(az+180,360);
  illum:=1;
  RowCount:=i+1;
  cells[0,0]:=pla[ipla];
  cells[0,1]:=trim(armtostr(h))+' UT';
  cells[0,i]:=isodate(a,m,d);
  cells[1,i]:=artostr(ar);
  cells[2,i]:=detostr(de);
  cells[3,i]:='-';
  cells[4,i]:=floattostrf(diam,ffFixed,6,1);
  cells[5,i]:=floattostrf(illum,ffFixed,6,2);
  cells[9,i]:=demtostr(az);
  cells[10,i]:=demtostr(ha);
  RiseSet(2,jd0,ar,de,hr,ht,hs,azr,azs,irc);
  case irc of
       0 : begin
           cells[6,i]:=armtostr(hr); cells[7,i]:=armtostr(ht); cells[8,i]:=armtostr(hs);
           objects[6,i]:=SetObjCoord(jda+(hr-timebias-h)/24,ar,de);
           objects[7,i]:=SetObjCoord(jda+(ht-timebias-h)/24,ar,de);
           objects[8,i]:=SetObjCoord(jda+(hs-timebias-h)/24,ar,de);
           end;
       1 : begin
           cells[6,i]:='-'; cells[7,i]:=armtostr(ht); cells[8,i]:='-';
           objects[7,i]:=SetObjCoord(jda+(ht-timebias-h)/24,ar,de);
           objects[6,i]:=nil;
           objects[8,i]:=nil;
           end;
       2 : begin
           cells[6,i]:='-'; cells[7,i]:='-'; cells[8,i]:='-';
           objects[6,i]:=nil;
           objects[7,i]:=nil;
           objects[8,i]:=nil;
           end;
  end;
 end;
11 : with Lunegrid do begin
  Lune(jda+jdt_ut,ar,de,dist,dkm,diam,phase,illum);
  if PlanetParalaxe then begin
     Paralaxe(st0,dist,ar,de,ar,de,q);
     diam:=diam/q;
  end;
  magn:=MoonMag(phase);
  objects[0,i]:=SetObjCoord(jda,ar,de);
  Horizontal((st0-ar)*15,de,az,ha);
  if AzNorth then az:=rmod(az+180,360);
  RowCount:=i+2;
  cells[0,0]:=pla[ipla];
  cells[0,1]:=trim(armtostr(h))+' UT';
  cells[0,i]:=isodate(a,m,d);
  cells[1,i]:=artostr(ar);
  cells[2,i]:=detostr(de);
  cells[3,i]:=floattostrf(magn,ffFixed,5,1);
  cells[4,i]:=floattostrf(diam,ffFixed,6,1);
  cells[5,i]:=floattostrf(illum,ffFixed,6,2);
  cells[9,i]:=demtostr(az);
  cells[10,i]:=demtostr(ha);
  Lune(jd0-timebias/24-1,am1,dm1,dist,dkm,diam,phase,illum);
  if (am1<0) then am1:=am1+24;
  Lune(jd0-timebias/24,am2,dm2,dist,dkm,diam,phase,illum);
  if (am2<0) then am2:=am2+24;
  Lune(jd0-timebias/24+1,am3,dm3,dist,dkm,diam,phase,illum);
  if (am3<0) then am3:=am3+24;
  RiseSetInt(3,jd0,am1,dm1,am2,dm2,am3,dm3,hr,ht,hs,azr,azs,irc);
  if s=1 then begin
    PlanetRiseCell(Lunegrid,i,irc,hr,ht,hs,azr,azs,jda,h,ar,de);
  end else begin
    jdcor:=0;
    mr:='   ';mt:='   ';ms:='   ';
    if hr<0 then begin mr:='d-1'; hr:=hr+24; jdcor:=-1; end;
    if hr>24 then begin mr:='d+1'; hr:=hr-24; jdcor:=1; end;
    if ht<0 then begin mt:='d-1'; ht:=ht+24; jdcor:=-1; end;
    if ht>24 then begin mt:='d+1'; ht:=ht-24; jdcor:=1; end;
    if hs<0 then begin ms:='d-1'; hs:=hs+24; jdcor:=-1; end;
    if hs>24 then begin ms:='d+1'; hs:=hs-24; jdcor:=1; end;
    case irc of
       0 : begin
           cells[6,i]:=mr+' '+armtostr(hr);
           cells[7,i]:=mt+' '+armtostr(ht);
           cells[8,i]:=ms+' '+armtostr(hs);
           objects[6,i]:=SetObjCoord(jda+jdcor+(hr-timebias-h)/24,ar,de);
           objects[7,i]:=SetObjCoord(jda+jdcor+(ht-timebias-h)/24,ar,de);
           objects[8,i]:=SetObjCoord(jda+jdcor+(hs-timebias-h)/24,ar,de);
           end;
       1 : begin
           cells[6,i]:='-';
           cells[7,i]:=mt+' '+armtostr(ht);
           cells[8,i]:='-';
           objects[7,i]:=SetObjCoord(jda+jdcor+(ht-timebias-h)/24,ar,de);
           objects[6,i]:=nil;
           objects[8,i]:=nil;
           end;
       2 : begin
           cells[6,i]:='-';
           cells[7,i]:='-';
           cells[8,i]:='-';
           objects[6,i]:=nil;
           objects[7,i]:=nil;
           objects[8,i]:=nil;
           end;
    end;
  end;
 end;
end;
end;
jda:=jda+s;
i:=i+1;
until jda>jd2;
LuneGrid.RowCount:=LuneGrid.Rowcount-1;
end;
finally
Planningform.SoleilGrid.Visible:=true;
Planningform.MercureGrid.Visible:=true;
Planningform.VenusGrid.Visible:=true;
Planningform.LuneGrid.Visible:=true;
Planningform.MarsGrid.Visible:=true;
Planningform.JupiterGrid.Visible:=true;
Planningform.SaturneGrid.Visible:=true;
Planningform.UranusGrid.Visible:=true;
Planningform.NeptuneGrid.Visible:=true;
Planningform.PlutonGrid.Visible:=true;
screen.cursor:=crDefault;
end;
end;

procedure Solarlist;
var f : textfile;
    buf,mm,siecle,pathimage : string;
    h,jda : double;
    i,n,a,m,j : integer;
begin
chdir(appdir);
with planningform do begin
dat41:=jdcalendar1.JD;
j:=jdcalendar1.year;
if j>0 then begin
  j:=j-1;
  siecle:=padzeros(inttostr(1+((abs(j)) div 100)),2);
end else begin
  siecle:=padzeros(inttostr(((abs(j)) div 100)),2);
  siecle:='-'+siecle;
end;
if Siecle_Solar<>Siecle then begin // lire le fichier la premiere fois
FreeCoord(Solargrid);
solargrid.RowCount:=3;
for i:=0 to solargrid.ColCount do solargrid.Cells[i,2]:='';
if not fileexists(orbites.planetpath+'\eclipses\solar'+siecle+'.txt') then exit;
screen.cursor:=crHourglass;
try
Filemode:=0;
Assignfile(f,orbites.planetpath+'\eclipses\solar'+siecle+'.txt');
reset(f);
i:=2;
solargrid.visible:=false;
repeat
Readln(f,buf);
with solargrid do begin
  RowCount:=i+1;
  cells[0,i]:=copy(buf,1,12);
  cells[1,i]:=copy(buf,15,5);
  cells[2,i]:=copy(buf,23,3);
  cells[3,i]:=copy(buf,26,4);
  cells[4,i]:=copy(buf,31,6);
  cells[5,i]:=copy(buf,39,5);
  cells[6,i]:=copy(buf,46,5);
  cells[7,i]:=copy(buf,52,6);
  cells[8,i]:=copy(buf,60,2);
  cells[9,i]:=copy(buf,63,4);
  cells[10,i]:=copy(buf,69,6);
  pathimage:=orbites.planetpath+'\eclipses\SE'+stringreplace(cells[0,i],' ','',[rfReplaceAll])+copy(cells[2,i],1,1)+'.gif';
  if fileexists(pathimage) then cells[11,i]:='Map'
                           else cells[11,i]:='';
  a:=strtointdef(copy(cells[0,i],1,5),-9999);
  mm:=copy(cells[0,i],7,3);
  m:=0;
  for n:=1 to 12 do
      if mm=monthlst[n] then begin
         m:=n;
         break;
      end;
  j:=strtointdef(copy(cells[0,i],11,2),0);
  if (a<>-9999)and(m<>0)and(j<>0) then begin
     h:=strtofloat(copy(cells[1,i],1,2))+strtofloat(copy(cells[1,i],4,2))/60;
     jda:=jd(a,m,j,h);
     objects[0,i]:=SetObjCoord(jda,-1000,-1000);
  end;
end;
i:=i+1;
until eof(f);
Siecle_Solar:=siecle;
finally
solargrid.visible:=true;
Closefile(f);
screen.cursor:=crDefault;
end;
end; // fin lecture fichier
a:=jdcalendar1.year;
with solargrid do begin
  for i:=2 to rowcount-1 do begin
     if strtoint(copy(cells[0,i],1,5))=a then begin
        toprow:=i;
        break;
     end;
     if strtoint(copy(cells[0,i],1,5))>a then begin
        toprow:=i-1;
        break;
     end;
  end;
end;
end;
end;

procedure Lunarlist;
var f : textfile;
    buf,mm,siecle : string;
    h,jda : double;
    i,n,a,m,j : integer;
begin
chdir(appdir);
with planningform do begin
dat51:=jdcalendar1.jd;
j:=jdcalendar1.year;
if j>0 then begin
  j:=j-1;
  siecle:=padzeros(inttostr(1+((abs(j)) div 100)),2);
end else begin
  siecle:=padzeros(inttostr(((abs(j)) div 100)),2);
  siecle:='-'+siecle;
end;
if Siecle_Lunar<>Siecle then begin // lire le fichier la premiere fois
FreeCoord(Lunargrid);
lunargrid.RowCount:=3;
for i:=0 to lunargrid.ColCount do lunargrid.Cells[i,2]:='';
if not fileexists(orbites.planetpath+'\eclipses\lunar'+siecle+'.txt') then exit;
screen.cursor:=crHourglass;
try
Filemode:=0;
Assignfile(f,orbites.planetpath+'\eclipses\lunar'+siecle+'.txt');
reset(f);
i:=2;
lunargrid.visible:=false;
repeat
Readln(f,buf);
with lunargrid do begin
  RowCount:=i+1;
  cells[0,i]:=copy(buf,1,12);
  cells[1,i]:=copy(buf,15,5);
  cells[2,i]:=copy(buf,21,3);
  cells[3,i]:=copy(buf,25,3);
  cells[4,i]:=copy(buf,30,6);
  cells[5,i]:=copy(buf,38,5);
  cells[6,i]:=copy(buf,44,6);
  cells[7,i]:=copy(buf,51,4);
  cells[8,i]:=copy(buf,56,4);
  a:=strtointdef(copy(cells[0,i],1,5),-9999);
  mm:=copy(cells[0,i],7,3);
  m:=0;
  for n:=1 to 12 do
      if mm=monthlst[n] then begin
         m:=n;
         break;
      end;
  j:=strtointdef(copy(cells[0,i],11,2),0);
  if (a<>-9999)and(m<>0)and(j<>0) then begin
     h:=strtofloat(copy(cells[1,i],1,2))+strtofloat(copy(cells[1,i],4,2))/60;
     jda:=jd(a,m,j,h);
     objects[0,i]:=SetObjCoord(jda,-1000,-1000);
  end;
end;
i:=i+1;
until eof(f);
Siecle_Lunar:=siecle;
finally
lunargrid.visible:=true;
Closefile(f);
screen.cursor:=crDefault;
end;
end; // fin lecture fichier
a:=jdcalendar1.year;
with lunargrid do begin
  for i:=2 to rowcount-1 do begin
     if strtoint(copy(cells[0,i],1,5))=a then begin
        toprow:=i;
        break;
     end;
     if strtoint(copy(cells[0,i],1,5))>a then begin
        toprow:=i-1;
        break;
     end;
  end;
end;
end;
end;

Procedure QuickSat(y,m,startd,endd,maglimit,tle : string;fullday:boolean);
var i : integer;
    satctl : textfile;
    buf,s1,s2,s3 : string;
    a1,a2,d1,d2,d : double;
const b = '          ';
begin
buf:=slash(appdir)+satpath+'\output.txt';
deletefile(buf);
try
buf:=slash(appdir)+satpath+'\quicksat.ctl';
assignfile(satctl,buf);
rewrite(satctl);
buf:=copy(y+b,1,4)+' '+copy(m+b,1,2); // 2001  4 Year, month number
writeln(satctl,buf);
buf:=copy(startd+b,1,2)+' '+copy(endd+b,1,2);  //24 0 Start date, end date
writeln(satctl,buf);
if fullday then buf:='0 24 A'       //-0.3 +0.3   Start time, end time, "A" flag
           else buf:='-0.3 +0.3';   //-0.3 +0.3   Start time, end time, "A" flag
writeln(satctl,buf);
//46.1  -6.2  1125.  Geneve
str(ObsLatitude:8:4,s1); buf:=s1;
str(ObsLongitude:8:4,s1); buf:=buf+' '+s1;
str(ObsAltitude*3.281:6:1,s1); buf:=buf+' '+s1+' '+ObsNom;
writeln(satctl,buf);
buf:=floattostr(timebias)+' '+'XXX 24';   //2 HEC 24 correction for UT to time zone, time zone name, 12/24 flag
writeln(satctl,buf);
buf:='2000 ';  //2000 Epoch of predicted RA, Dec
writeln(satctl,buf);
buf:=maglimit;  //6.5 Magnitude limit
writeln(satctl,buf);
buf:='5  ';  //5 Altitude cut-off value
writeln(satctl,buf);
buf:='0.2 '; //0.2 The search/step parameter value
writeln(satctl,buf);
buf:='F ';   //F True means store all elements in memory (limit 2000)
writeln(satctl,buf);
buf:='T ';   //T True means accept only the most recent elements for each object
writeln(satctl,buf);
buf:='F ';   //F True means ignore shadow test
writeln(satctl,buf);
buf:='F  99 '; //F  99 True means generate multiple prediction points, how many each way
writeln(satctl,buf);
buf:='F ';   //F True means output distance values in miles
writeln(satctl,buf);
buf:='F ';   //F True means generate a blank line before each object's prediction.
writeln(satctl,buf);
//           Up to 5 non-blank flags to select class(es) of objects
{$IFNDEF CALENDAR}            
if planningform.SatChartBox.checked then begin
   buf:='RD         ';
   writeln(satctl,buf);
   a1:=ar1; a2:=ar2; d1:=de1; d2:=de2;
   d:=AngularDistance(15*a1,d1,15*a2,d1);
   if d<15 then begin // recherche dans un champ de 15d min.
      d:= sqrt((15-d)*(15-d)/2)/2;
      d1:=maxvalue([d1-d,-90]);
      d2:=minvalue([d2+d,90]);
      if abs(decentre)<89 then begin
         d:=d/15/cos(degtorad(decentre));
         a1:=a1-d;
         a2:=a2+d;
      end;
   end;
   artostr2(a1,s1,s2,s3);  buf:=s1+' '+s2;
   artostr2(a2,s1,s2,s3);  buf:=buf+' '+s1+' '+s2;
   str(d1:5:1,s1);  buf:=buf+' '+s1;
   str(d2:5:1,s1);  buf:=buf+' '+s1;
end else {$ENDIF} buf:='           ';
writeln(satctl,buf);
buf:='B   N        ';  //B   N        Output format flag, R/P option, D/C/N option, Azimuth option
writeln(satctl,buf);
buf:='quicksat.mag';  //quicksat.mag      Intrinsic magnitudes input file
writeln(satctl,buf);
buf:='none        ';  //none              Intrinsic magnitudes override file
writeln(satctl,buf);
buf:='output.txt';    //output.txt        Output file
writeln(satctl,buf);
s1:=planningform.tle.text;
i:=pos(',',s1);
if i>0 then repeat
   buf:=copy(s1,1,i-1);
   s1:=copy(s1,i+1,9999);
   writeln(satctl,buf);
   i:=pos(',',s1);
until i=0;
buf:=s1;                // visual.txt        Elements input file
writeln(satctl,buf);
buf:='EOF'; //EOF               End of input file list
writeln(satctl,buf);
Closefile(satctl);
chdir(slash(appdir)+satpath);
application.processmessages;
exec('command.com /C quicksat.exe',false);
application.processmessages;
chdir(appdir);
except
{$I-}
Closefile(satctl);
dummy_double:=ioresult;
{$I+}
chdir(appdir);
raise;
end;
end;

Procedure DetailSat(jds : double);
var
    satctl : textfile;
    buf,s1,s2,s3,s4 : string;
    x1 : double;
    i1,i2,i3 : integer;
    a1,a2,d1,d2,d : double;
const b = '          ';
      dt = 0.1 ; // heures
begin
deletefile(slash(appdir)+satpath+'\output.txt');
try
assignfile(satctl,slash(appdir)+satpath+'\quicksat.ctl');
rewrite(satctl);
// start time
djd(jds-dt/24,i1,i2,i3,x1);
buf:=copy(inttostr(i1)+b,1,4)+' '+copy(inttostr(i2)+b,1,2); // 2001  4 Year, month number
writeln(satctl,buf);
s1:=copy(inttostr(i3)+b,1,2);
str(x1:4:1,s2);
str(x1+2*dt:4:1,s4);
{djd(jds+dt/24,i1,i2,i3,x1);
s3:=copy(inttostr(i3)+b,1,2);
str(x1:4:1,s4);}
//buf:=s1+' '+s3;          //24 0 Start date, end date
buf:=s1+' '+s1;          //24 0 Start date, end date
writeln(satctl,buf);
buf:=s2+' '+s4+' A ';  //-0.3 +0.3   Start time, end time, "A" flag
writeln(satctl,buf);
//46.1  -6.2  1125.  Geneve
//str(ObsLatitude:4:1,s1); buf:=s1;
//str(ObsLongitude:6:1,s1); buf:=buf+' '+s1;
str(ObsLatitude:8:4,s1); buf:=s1;
str(ObsLongitude:8:4,s1); buf:=buf+' '+s1;
str(ObsAltitude*3.281:6:1,s1); buf:=buf+' '+s1+' '+ObsNom;
writeln(satctl,buf);
buf:=floattostr(timebias)+' '+'XXX 24';   //2 HEC 24 correction for UT to time zone, time zone name, 12/24 flag
//buf:='0 '+'XXX 24';   //2 HEC 24 correction for UT to time zone, time zone name, 12/24 flag
writeln(satctl,buf);
buf:='2000 ';  //2000 Epoch of predicted RA, Dec
writeln(satctl,buf);
buf:=planningform.magchart.text;  //6.5 Magnitude limit
writeln(satctl,buf);
buf:='5  ';  //5 Altitude cut-off value
writeln(satctl,buf);
buf:='0.2 '; //0.2 The search/step parameter value
writeln(satctl,buf);
buf:='F ';   //F True means store all elements in memory (limit 2000)
writeln(satctl,buf);
buf:='T ';   //T True means accept only the most recent elements for each object
writeln(satctl,buf);
buf:='F ';   //F True means ignore shadow test
writeln(satctl,buf);
buf:='T  99 '; //F  99 True means generate multiple prediction points, how many each way
writeln(satctl,buf);
buf:='F ';   //F True means output distance values in miles
writeln(satctl,buf);
buf:='F ';   //F True means generate a blank line before each object's prediction.
writeln(satctl,buf);
//           Up to 5 non-blank flags to select class(es) of objects
{$IFNDEF CALENDAR}
if planningform.SatChartBox.checked then begin
   buf:='RD         ';
   writeln(satctl,buf);
   a1:=ar1; a2:=ar2; d1:=de1; d2:=de2;
   d:=AngularDistance(15*a1,d1,15*a2,d1);
   if d<15 then begin // recherche dans un champ de 15d min.
      d:= sqrt((15-d)*(15-d)/2)/2;
      d1:=maxvalue([d1-d,-90]);
      d2:=minvalue([d2+d,90]);
      if abs(decentre)<89 then begin
         d:=d/15/cos(degtorad(decentre));
         a1:=a1-d;
         a2:=a2+d;
      end;
   end;
   artostr2(a1,s1,s2,s3);  buf:=s1+' '+s2;
   artostr2(a2,s1,s2,s3);  buf:=buf+' '+s1+' '+s2;
   str(d1:5:1,s1);  buf:=buf+' '+s1;
   str(d2:5:1,s1);  buf:=buf+' '+s1;
end else {$ENDIF} buf:='           ';
writeln(satctl,buf);
buf:='B   N        ';  //B   N        Output format flag, R/P option, D/C/N option, Azimuth option
writeln(satctl,buf);
buf:='quicksat.mag';  //quicksat.mag      Intrinsic magnitudes input file
writeln(satctl,buf);
buf:='none        ';  //none              Intrinsic magnitudes override file
writeln(satctl,buf);
buf:='output.txt';    //output.txt        Output file
writeln(satctl,buf);
s1:=planningform.tle.text;
i1:=pos(',',s1);
if i1>0 then repeat
   buf:=copy(s1,1,i1-1);
   s1:=copy(s1,i1+1,9999);
   writeln(satctl,buf);
   i1:=pos(',',s1);
until i1=0;
buf:=s1;                // visual.txt        Elements input file
writeln(satctl,buf);
buf:='EOF'; //EOF               End of input file list
writeln(satctl,buf);
Closefile(satctl);
chdir(slash(appdir)+satpath);
application.processmessages;
exec('command.com /C quicksat.exe',true);
application.processmessages;
chdir(appdir);
except
{$I-}
Closefile(satctl);
i1:=ioresult;
{$I+}
chdir(appdir);
raise;
end;
end;

Procedure Iridium(y,mm,d,dt : string);
var irictl : textfile;
    buf : string;
begin
deletefile(slash(appdir)+satpath+'\iridflar.out');
try
assignfile(irictl,slash(appdir)+satpath+'\iridflar.cfg');
rewrite(irictl);
buf:='[IRIDFLAR]';
writeln(irictl,buf);
buf:='EphemFile=iridium.tle';
writeln(irictl,buf);
buf:='CityFile=skymap.cty';
writeln(irictl,buf);
buf:='SiteName='+Obsnom;
writeln(irictl,buf);
buf:='ReportFile=iridflar.out';
writeln(irictl,buf);
buf:='StartDate='+y+'/'+mm+'/'+d;
writeln(irictl,buf);
buf:='StartTime=12:00:00';
writeln(irictl,buf);
buf:='Lat='+floattostr(Obslatitude);
writeln(irictl,buf);
buf:='Long='+floattostr(-Obslongitude);
writeln(irictl,buf);
buf:='Alt='+floattostr(Obsaltitude);
writeln(irictl,buf);
buf:='Zone='+floattostr(timebias);
writeln(irictl,buf);
buf:='SearchDur='+dt;
writeln(irictl,buf);
buf:='SunAng= -6.00';
writeln(irictl,buf);
buf:='MinElev=10.00';
writeln(irictl,buf);
buf:='MaxMirror= 4.00';
writeln(irictl,buf);
buf:='DayMagLim=-6.0';
writeln(irictl,buf);
buf:='NightMagLim= 2.0';
writeln(irictl,buf);
buf:='Units=Metric';
writeln(irictl,buf);
buf:='Source=Sun';
writeln(irictl,buf);
buf:='Batch=Yes';
writeln(irictl,buf);
buf:='Brief=No';
writeln(irictl,buf);
buf:='LocalStart=Yes';
writeln(irictl,buf);
buf:='AutoDate=No';
writeln(irictl,buf);
buf:='ThreeLines=No';
writeln(irictl,buf);
buf:='Report=Yes';
writeln(irictl,buf);
Closefile(irictl);
chdir(slash(appdir)+satpath);
exec('command.com /C iridflar.exe',false);
application.processmessages;
chdir(appdir);
except
{$I-}
Closefile(irictl);
dummy_double:=ioresult;
{$I+}
chdir(appdir);
raise;
end;
end;

procedure Satlist;
var f,fi : textfile;
    buf,mm,y,d,ed,dt,hh,mi,ss,dat1,s1,s2 : string;
    bufi : string;
    h,jda,ar,de,ma : double;
    hi,jdi,ari,dei : double;
    i,k,a,m,j : integer;
    ai,mmi,ji : integer;
const mois : array[1..12]of string = ('Jan ','Feb ','Mar ','Apr ','May ','June','July','Aug ','Sept','Oct ','Nov ','Dec ');
Procedure InsertIridium;
  begin
  with planningform.SatGrid do
  while jdi<jda do begin
    RowCount:=i+1;
    cells[0,i]:=inttostr(ai)+'-'+padzeros(inttostr(mmi),2)+'-'+padzeros(inttostr(ji),2)+' '+copy(bufi,18,8);
    cells[1,i]:='Flare: Iridium '+copy(bufi,1,5);
    cells[2,i]:=copy(bufi,79,4);
    cells[3,i]:=copy(bufi,29,3);
    cells[4,i]:=copy(bufi,33,2);
    cells[5,i]:=copy(bufi,48,4);
    s1:=padzeros(copy(bufi,36,2),2);
    s2:=padzeros(copy(bufi,39,2),2);
    ari:=strtoint(s1)+strtoint(s2)/60;
    cells[6,i]:=s1+'h'+s2+'m';
    cells[7,i]:=copy(bufi,42,5);
    dei:=strtofloat(cells[7,i]);
    cells[8,i]:=trim(copy(bufi,113,7));
    cells[9,i]:='';
    objects[0,i]:=SetObjCoord(jdi,ari,dei);
    i:=i+1;
    if eof(fi) then begin
       jdi:=99999999;
       Closefile(fi);
       end
    else begin
      Readln(fi,bufi);
      if trim(bufi)='' then Readln(fi,bufi);
      if copy(bufi,1,5)='-----' then begin
         jdi:=99999999;
         Closefile(fi);
         end
      else begin
      ai:=strtoint(copy(bufi,7,4));
      mmi:=strtoint(copy(bufi,12,2));
      ji:=strtoint(copy(bufi,15,2));
      hi:=strtoint(copy(bufi,18,2))+strtoint(copy(bufi,21,2))/60+strtoint(copy(bufi,24,2))/3600;
      jdi:=jd(ai,mmi,ji,hi-timebias);
      end;
    end;
  end;
end;
// debut ici
begin
with planningform do begin
dat61:=jdcalendar1.jd;
case jdcalendar1.year of
-99999..1900 : begin
               showmessage('Sorry, It''s hard to find an artificial satellite at this date !');
               exit;
               end;
  1901..1956 : begin
               showmessage('Whoo! Yuri was to young to fly !');
               exit;
               end;
end;
y:=inttostr(jdcalendar1.year);
mm:=inttostr(jdcalendar1.month);
d:=inttostr(jdcalendar1.day);
ed:=inttostr(strtoint(d)+round(jdcalendar2.jd-jdcalendar1.jd));
dt:=inttostr(1+Trunc(jdcalendar2.jd-jdcalendar1.jd));
QuickSat(y,mm,d,ed,maglimit.text,tle.text,fullday.Checked);
if IridiumBox.Checked then Iridium(y,mm,d,dt);
FreeCoord(Satgrid);
satgrid.RowCount:=3;
//Filemode:=0;
if not Fileexists(slash(appdir)+satpath+'\output.txt') then raise Exception.Create('Satellites file error');
try
screen.cursor:=crHourglass;
Assignfile(f,slash(appdir)+satpath+'\output.txt');
reset(f);
jdi:=1;
if IridiumBox.Checked then begin
  Assignfile(fi,slash(appdir)+satpath+'\iridflar.out');
  reset(fi);
  repeat
    Readln(fi,bufi);
    if eof(fi) then begin
      jdi:=99999999;
      Closefile(fi);
      break;
    end;
  until copy(bufi,1,5)='-----';
  if jdi<>99999999 then begin
     Readln(fi,bufi);
     ai:=strtoint(copy(bufi,7,4));
     mmi:=strtoint(copy(bufi,12,2));
     ji:=strtoint(copy(bufi,15,2));
     hi:=strtoint(copy(bufi,18,2))+strtoint(copy(bufi,21,2))/60+strtoint(copy(bufi,24,2))/3600;
     jdi:=jd(ai,mmi,ji,hi-timebias);
  end;
end;
i:=2;
satgrid.visible:=false;
Readln(f,buf);
Readln(f,buf);
m:=1;a:=1;j:=1;
repeat
Readln(f,buf);
if copy(buf,1,3)='***' then begin
  satgrid.RowCount:=i+1;
  y:=copy(buf,6,4); a:=strtoint(y);
  mm:=copy(buf,11,4); for k:=1 to 12 do if mm=mois[k] then m:=k;
  d:=copy(buf,16,2); j:=strtoint(d);
  dat1:=y+'-'+padzeros(inttostr(m),2)+'-'+padzeros(d,2);
  Readln(f,buf);
  Readln(f,buf);
  continue;
end;
if trim(buf)='' then continue;
hh:=padzeros(copy(buf,1,2),2);
mi:=padzeros(copy(buf,4,2),2);
ss:=padzeros(copy(buf,7,2),2);
h:=strtoint(hh)+strtoint(mi)/60+strtoint(ss)/3600;
jda:=jd(a,m,j,h-timebias);
with satgrid do begin
  if IridiumBox.Checked and(jdi<jda) then InsertIridium;
  RowCount:=i+1;
  cells[0,i]:=dat1+' '+hh+':'+mi+':'+ss;
  cells[1,i]:=copy(buf,66,99);
  ma:=strtofloat(copy(buf,26,4));
  if ma>17.9 then begin
     ma:=(ma-20+6);
     str(ma:4:1,s1);
     cells[2,i]:='('+s1+')';
  end else cells[2,i]:=copy(buf,26,4);
  cells[3,i]:=copy(buf,14,3);
  cells[4,i]:=copy(buf,18,2);
  cells[5,i]:=copy(buf,46,4);
  s1:=padzeros(copy(buf,51,2),2);
  s2:=padzeros(copy(buf,53,2),2);
  ar:=strtoint(s1)+strtoint(s2)/60;
  cells[6,i]:=s1+'h'+s2+'m';
  cells[7,i]:=copy(buf,55,5);
  de:=strtofloat(cells[7,i]);
  cells[8,i]:=copy(buf,9,4);
  cells[9,i]:=copy(buf,22,3);
  objects[0,i]:=SetObjCoord(jda,ar,de);
end;
i:=i+1;
until eof(f);
jda:=99999999;
if IridiumBox.Checked and(jdi<>99999999) then InsertIridium; // ne pas oublier les derniers
finally
satgrid.visible:=true;
{$I-}
Closefile(f);
if IridiumBox.Checked and (jdi<>99999999) then Closefile(fi);
i:=ioresult;
{$I+}
screen.cursor:=crDefault;
PlanningForm.BringToFront;
PlanningForm.Show;
end;
end; 
end;

procedure TPlanningForm.BitBtn1Click(Sender: TObject);
begin
chdir(appdir);
PlanningForm.caption:=titre+' '+Obsnom;
screen.cursor:=crHourGlass;
case pagecontrol1.ActivePage.TabIndex of
     0 : crepuslist;
     1 : planetlist;
     2 : cometelist;
     3 : Solarlist;
     4 : Lunarlist;
     5 : Satlist;
end;
screen.cursor:=crDefault;
end;

procedure TPlanningForm.FormShow(Sender: TObject);
var buf,d : string;
    x : double;
begin
if initial then begin
crepuslist;
planetlist;
if stringgrid1.cells[0,2]<>'' then cometelist;
initial:=false;
end;
x:=abs(timebias);
if timebias<0 then d:=west else d:=east;
buf:=tz+'='+timtostr(x)+d;
PlanningForm.caption:=titre+' '+Obsnom+' '+buf;
end;

Procedure Dateligne1(onoff : boolean);
begin
with planningform do begin
label2.visible:=onoff;
jdcalendar2.visible:=onoff;
end;
end;

Procedure Dateligne2(onoff : boolean);
begin
with planningform do begin
label3.visible:=onoff;
label4.visible:=onoff;
label5.visible:=onoff;
edit1.visible:=onoff;
datetimepicker3.visible:=onoff;
EcliPanel.visible:=false;
SatPanel.visible:=false;
TLEbtn.visible:=false;
end;
end;

procedure TPlanningForm.PageControl1Change(Sender: TObject);
begin
case pagecontrol1.ActivePage.TabIndex of
     0 : begin
         Dateligne1(true);
         Dateligne2(true);
         if (dat11<>jdcalendar1.jd)or(dat12<>jdcalendar2.jd)or(dat13<>datetimepicker3.datetime)or(dat14<>edit1.text)or(obsnom<>calobs1) then
            crepuslist;
         end;
     1 : begin
         Dateligne1(true);
         Dateligne2(true);
         if (dat21<>jdcalendar1.jd)or(dat22<>jdcalendar2.jd)or(dat23<>datetimepicker3.datetime)or(dat24<>edit1.text)or(obsnom<>calobs2) then
            planetlist;
         end;
     2 : begin
         Dateligne1(true);
         Dateligne2(true);
         if showcomet and((dat31<>jdcalendar1.jd)or(dat32<>jdcalendar2.jd)or(dat33<>datetimepicker3.datetime)or(dat34<>edit1.text)or(obsnom<>calobs3)) then
            cometelist;
         end;
     3 : begin
         Dateligne1(false);
         Dateligne2(false);
         EcliPanel.Visible:=true;
         if (dat41<>jdcalendar1.jd) then Solarlist;
         end;
     4 : begin
         Dateligne1(false);
         Dateligne2(false);
         EcliPanel.Visible:=true;
         if (dat51<>jdcalendar1.jd) then Lunarlist;
         end;
     5 : begin
         Dateligne1(true);
         Dateligne2(false);
         SatPanel.Visible:=true;
         TLEbtn.visible:=true;
         end;

end;
end;

procedure TPlanningForm.BitBtn3Click(Sender: TObject);
begin
case pagecontrol1.ActivePage.TabIndex of
0 : showhelp('doc4.html');
1 : showhelp('doc4.html#planetes');
2 : showhelp('doc4.html#cometes');
3 : showhelp('doc4.html#solareclipses');
4 : showhelp('doc4.html#lunareclipses');
5 : showhelp('doc4.html#satellites');
end;
end;

procedure TPlanningForm.BitBtn2Click(Sender: TObject);
begin
PlanningForm.Close;
end;

procedure TPlanningForm.BitBtn4Click(Sender: TObject);
var buf,d : string;
    x : double;
begin
buf:=ObsNom+' ';
x:=abs(timebias);
if timebias<0 then d:=west else d:=east;
buf:=buf+tz+'='+timtostr(x)+d;
case pagecontrol1.ActivePage.TabIndex of
 0 : begin
       jvGridPrinter1.Grid:=StringGrid2;
       jvGridPrinter1.PrintOptions.Orientation:=poPortrait;
       jvGridPrinter1.PrintOptions.PageTitle:=crepuscule.caption+'   '+buf;
       jvGridPrinter1.Print;
     end;
 1 : case pagecontrol2.ActivePage.TabIndex of
     0 : begin
           jvGridPrinter1.Grid:=SoleilGrid;
           jvGridPrinter1.PrintOptions.Orientation:=poPortrait;
           jvGridPrinter1.PrintOptions.PageTitle:=psoleil.caption+'   '+buf;
           jvGridPrinter1.Print;
         end;
     1 : begin
           jvGridPrinter1.Grid:=MercureGrid;
           jvGridPrinter1.PrintOptions.Orientation:=poPortrait;
           jvGridPrinter1.PrintOptions.PageTitle:=mercure.caption+'   '+buf;
           jvGridPrinter1.Print;
         end;
     2 : begin
           jvGridPrinter1.Grid:=VenusGrid;
           jvGridPrinter1.PrintOptions.Orientation:=poPortrait;
           jvGridPrinter1.PrintOptions.PageTitle:=venus.caption+'   '+buf;
           jvGridPrinter1.Print;
         end;
     3 : begin
           jvGridPrinter1.Grid:=LuneGrid;
           jvGridPrinter1.PrintOptions.Orientation:=poPortrait;
           jvGridPrinter1.PrintOptions.PageTitle:=plune.caption+'   '+buf;
           jvGridPrinter1.Print;
         end;
     4 : begin
           jvGridPrinter1.Grid:=MarsGrid;
           jvGridPrinter1.PrintOptions.Orientation:=poPortrait;
           jvGridPrinter1.PrintOptions.PageTitle:=Mars.caption+'   '+buf;
           jvGridPrinter1.Print;
         end;
     5 : begin
           jvGridPrinter1.Grid:=JupiterGrid;
           jvGridPrinter1.PrintOptions.Orientation:=poPortrait;
           jvGridPrinter1.PrintOptions.PageTitle:=jupiter.caption+'   '+buf;
           jvGridPrinter1.Print;
         end;
     6 : begin
           jvGridPrinter1.Grid:=SaturneGrid;
           jvGridPrinter1.PrintOptions.Orientation:=poPortrait;
           jvGridPrinter1.PrintOptions.PageTitle:=saturne.caption+'   '+buf;
           jvGridPrinter1.Print;
         end;
     7 : begin
           jvGridPrinter1.Grid:=UranusGrid;
           jvGridPrinter1.PrintOptions.Orientation:=poPortrait;
           jvGridPrinter1.PrintOptions.PageTitle:=uranus.caption+'   '+buf;
           jvGridPrinter1.Print;
         end;
     8 : begin
           jvGridPrinter1.Grid:=NeptuneGrid;
           jvGridPrinter1.PrintOptions.Orientation:=poPortrait;
           jvGridPrinter1.PrintOptions.PageTitle:=neptune.caption+'   '+buf;
           jvGridPrinter1.Print;
         end;
     9 : begin
           jvGridPrinter1.Grid:=PlutonGrid;
           jvGridPrinter1.PrintOptions.Orientation:=poPortrait;
           jvGridPrinter1.PrintOptions.PageTitle:=pluton.caption+'   '+buf;
           jvGridPrinter1.Print;
         end;
     end;
 2 : begin
       jvGridPrinter1.Grid:=StringGrid1;
       jvGridPrinter1.PrintOptions.Orientation:=poLandscape;
       jvGridPrinter1.PrintOptions.PageTitle:=Combobox1.text+' '+buf;
       jvGridPrinter1.Print;
     end;
 3 : begin
       jvGridPrinter1.Grid:=SolarGrid;
       jvGridPrinter1.PrintOptions.Orientation:=poPortrait;
       jvGridPrinter1.PrintOptions.PageTitle:=Solar.caption;
       jvGridPrinter1.Print;
     end;
 4 : begin
       jvGridPrinter1.Grid:=LunarGrid;
       jvGridPrinter1.PrintOptions.Orientation:=poPortrait;
       jvGridPrinter1.PrintOptions.PageTitle:=Lunar.caption;
       jvGridPrinter1.Print;
     end;
 5 : begin
       jvGridPrinter1.Grid:=SatGrid;
       jvGridPrinter1.PrintOptions.Orientation:=poPortrait;
       jvGridPrinter1.PrintOptions.PageTitle:=Satellites.Caption+' '+buf;
       jvGridPrinter1.Print;
     end;
end;
end;

Procedure Gridetoclipboard(grid : tstringgrid);
var buf,d : string;
    i,j : integer;
    x : double;
begin
with planningform do begin
memo1.clear;
buf:='"'+ObsNom+'";"';
x:=abs(obslongitude);
if obslongitude>0 then d:=west else d:=east;
buf:=buf+appmsg[32]+'='+stringreplace(copy(detostr(x),2,99),'"','""',[rfReplaceAll])+d+'";"'+appmsg[31]+'='+stringreplace(detostr(obslatitude),'"','""',[rfReplaceAll])+'";"';
x:=abs(timebias);
if timebias<0 then d:=west else d:=east;
buf:=buf+tz+'='+timtostr(x)+d+'"';
memo1.Lines.add(buf);
for i:=0 to grid.RowCount-1 do begin
  for j:=0 to grid.ColCount-1 do begin
    if j=0 then buf:= '"'+stringreplace(grid.cells[j,i],'"','""',[rfReplaceAll])
           else buf:=buf+'";"'+stringreplace(grid.cells[j,i],'"','""',[rfReplaceAll]);
  end;
  buf:=buf+'"';
  memo1.Lines.add(buf);
end;
memo1.selectall;
memo1.copytoclipboard;
memo1.clear;
end;
end;

procedure TPlanningForm.BitBtn5Click(Sender: TObject);
begin
case pagecontrol1.ActivePage.TabIndex of
 0 : GridetoClipboard(StringGrid2);
 1 : case pagecontrol2.ActivePage.TabIndex of
     0 : GridetoClipboard(SoleilGrid);
     1 : GridetoClipboard(MercureGrid);
     2 : GridetoClipboard(VenusGrid);
     3 : GridetoClipboard(LuneGrid);
     4 : GridetoClipboard(MarsGrid);
     5 : GridetoClipboard(JupiterGrid);
     6 : GridetoClipboard(SaturneGrid);
     7 : GridetoClipboard(UranusGrid);
     8 : GridetoClipboard(NeptuneGrid);
     9 : GridetoClipboard(PlutonGrid);
     end;
 2 : GridetoClipboard(StringGrid1);
 3 : GridetoClipboard(SolarGrid);
 4 : GridetoClipboard(LunarGrid);
 5 : GridetoClipboard(SatGrid);
 end;
end;

procedure ShowObs;
begin
if debugon then writedebug('Create TSky_Locate1');
Application.CreateForm(TSky_Locate1, Sky_Locate1);
try
Sky_Locate.ar:=(Obslongitude+180)/15;
Sky_Locate.de:=Obslatitude;
FormPos(Sky_Locate.Sky_locate1,
          mouse.cursorpos.x,
          mouse.cursorpos.y);
Sky_Locate.Sky_locate1.caption:='Position de la plus grande eclipse';
Sky_locate1.image3.visible:=true;
Sky_locate1.image1.visible:=false;
Sky_locate1.BitBtn4.visible:=true;
Sky_Locate.Sky_locate1.ShowModal;
if Sky_Locate.Sky_locate1.ModalResult=mrOK then begin
  Obslongitude:=Sky_Locate.ar*15-180;
  Obslatitude:=Sky_Locate.de;
end;
finally
Sky_locate1.free;
if debugon then writedebug('Free TSky_Locate1');
end;
end;

procedure TPlanningForm.CoordGridMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  Column, Row: Longint;
  i : integer;
  a,d : double;
  p : TObjCoord;
  gr : Tstringgrid;
  pathimage : string;
  ok : boolean;
begin
try
{$IFNDEF CALENDAR}
ResetObs;
if TimeSkipForm.visible then TimeSkipForm.Hide;
{$ENDIF}
gr:=Tstringgrid(sender);
gr.MouseToCell(X, Y, Column, Row);
if (row>=0)and(Column>=0) then begin
  p:=TObjCoord(gr.Objects[Column,row]);
  if p=nil then p:=TObjCoord(gr.Objects[0,row]);
  if p<>nil then begin
    djd(p.jd+timebias/24,CurYear,CurrentMonth,CurrentDay,CurrentTime);
    DT_UT:=DTminusUT(CurYear);
    if gr = solargrid then  begin      // eclipse de Soleil
       if (Column=11) then begin   // path image
         pathimage:=orbites.planetpath+'\eclipses\SE'+stringreplace(gr.cells[0,row],' ','',[rfReplaceAll])+copy(gr.cells[2,row],1,1)+'.gif';
         if fileexists(pathimage) then begin
            if bigimaform=nil then Application.CreateForm(TBigImaForm, BigImaForm);
            if not bigimaform.visible then BigImaForm.Position:=poDesktopCenter;
            bigimaform.memo1.visible:=false;
            bigimaform.image1.visible:=true;
            BigImaform.Caption:=eclipanel.caption;
            bigimaform.image1.picture.LoadFromFile(pathimage);
            BigImaForm.Width:=trunc(minvalue([Screen.Width,bigimaform.image1.picture.Width+20]));
            BigImaForm.Height:=trunc(minvalue([Screen.Height,bigimaform.image1.picture.Height+40]));
            bigimaform.Show;
         end;
         exit;
       end;
{$IFNDEF CALENDAR}
       FollowOn:=true;
       FollowType:=1;
       FollowObj:=10;
       SaveObs;
       if (Column=6)or(Column=7) then begin
         d:=strtofloat(copy(gr.cells[6,row],1,4));
         if copy(gr.cells[6,row],5,1)='S' then d:=-d;
         a:=strtofloat(copy(gr.cells[7,row],1,5));
         if copy(gr.cells[7,row],6,1)='E' then a:=-a;
         ObsLatitude:=d;
         ObsLongitude:=a;
         ObsNom:='Ecl.'+inttostr(CurYear);
         ShowObs;
         Sky_P1.initObservatoire;
         PlanetParalaxe:=true;
         PlanetShow:=true;
{$ENDIF}
       end;
{$IFNDEF CALENDAR}
    end else if gr = lunargrid then begin
       FollowOn:=true;              // eclipse de Lune
       FollowType:=1;
       FollowObj:=11;
       PlanetParalaxe:=true;
       PlanetShow:=true;
       ShowEarthUmbra:=true;
    end else if gr = StringGrid1 then begin  // cometes
       ok:=false;
       for i:=1 to CometNb do if trim(ComboBox1.text)=trim(CometNlst[i]) then ok:=true;
       if not ok then begin
          CometNB:=CometNB+1;
          CometNlst[CometNB]:=ComboBox1.text;
          CheckCometes;
       end;
       if p.ra>-900 then skylib.arcentre:=p.ra;
       if p.dec>-900 then skylib.decentre:=p.dec
       else if skylib.Projpole=1 then begin
         Hz2Eq(skylib.acentre,skylib.hcentre,a,d);
         a:=15*SidTim(jd(CurYear,CurrentMonth,CurrentDay,0.0),CurrentTime-TimeBias,ObsLongitude)-a;
         skylib.decentre:=d;
         skylib.arcentre:=a/15;
         precession(jd(CurYear,CurrentMonth,CurrentDay,CurrentTime-TimeBias+DT_UT),jd2000,skylib.arcentre,skylib.decentre);
       end;
    end else if gr = Satgrid then begin    // Satellites
       DetailSat(p.jd);
       if not planningform.SatChartBox.checked then begin
         skylib.arcentre:=p.ra;
         skylib.decentre:=p.dec;
       end;
       sky_p1.NewTime:=true;
       sky_p1.ArtSatOn:=true;
       if copy(gr.cells[1,row],1,14)='Flare: Iridium' then begin
          sky_p1.IridiumRA:=p.ra;
          sky_p1.IridiumDE:=p.dec;
          sky_p1.IridiumMA:=strtofloat(gr.cells[2,row]);
          sky_p1.IridiumNom:=copy(gr.cells[1,row],8,99);
          sky_p1.IridiumDist:=gr.cells[5,row];
       end else sky_p1.IridiumMA:=99;
    end else begin
       if p.ra>-900 then skylib.arcentre:=p.ra;
       if p.dec>-900 then skylib.decentre:=p.dec
       else if skylib.Projpole=1 then begin
         Hz2Eq(skylib.acentre,skylib.hcentre,a,d);
         a:=15*SidTim(jd(CurYear,CurrentMonth,CurrentDay,0.0),CurrentTime-TimeBias,ObsLongitude)-a;
         skylib.decentre:=d;
         skylib.arcentre:=a/15;
         precession(jd(CurYear,CurrentMonth,CurrentDay,CurrentTime-TimeBias+DT_UT),jd2000,skylib.arcentre,skylib.decentre);
       end;
    end;
    sky_p1.NewTime:=true;
    sky_p1.TimerOn:=false;
    sky_p1.Form1.BringToFront;
    chdir(appdir);
    sky_p1.NewPosition;
{$ENDIF}
  end;
end;
{$IFNDEF CALENDAR}
if FollowOn then TimeSkipForm.Show;
{$ENDIF}
except
end;                           
end;

procedure TPlanningForm.TLEListBoxExit(Sender: TObject);
var i : integer;
    buf : string;
begin
with TLEListBox do begin
// Visible:=false;
 if selcount>0 then begin
    buf:='';
    for i:=0 to Items.Count-1 do if selected[i] then buf:=buf+','+Items.Strings[i];
    tle.text:=copy(buf,2,9999);
 end;
end;
end;

procedure TPlanningForm.EcliPanelClick(Sender: TObject);
const InfoUrl='http://sunearth.gsfc.nasa.gov/eclipse/eclipse.html';
begin
ExecuteFile(InfoUrl, '', '', SW_SHOWNOACTIVATE);
end;

procedure TPlanningForm.TLEBtnClick(Sender: TObject);
const InfoUrl='http://www.space-track.org';
      tleprog='TLE Download.exe';
begin
if fileexists(tleprog) then ExecuteFile(tleprog, '', '', SW_SHOWNOACTIVATE)
                       else ExecuteFile(InfoUrl, '', '', SW_SHOWNOACTIVATE);
end;

procedure TPlanningForm.SatPanelClick(Sender: TObject);
const InfoUrl='http://users2.ev1.net/~mmccants/';
begin
ExecuteFile(InfoUrl, '', '', SW_SHOWNOACTIVATE);
end;

procedure TPlanningForm.Label9Click(Sender: TObject);
const InfoUrl='http://users2.ev1.net/~mmccants/';
begin
ExecuteFile(InfoUrl, '', '', SW_SHOWNOACTIVATE);
end;

end.
